<?php
class ControllerCatalogInformation extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('catalog/information');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('catalog/information');

		$this->getList();
	}

	public function add() {
		$this->load->language('catalog/information');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('catalog/information');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->model_catalog_information->addInformation($this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('catalog/information', 'user_token=' . $this->session->data['user_token'] . $url, true));
		}

		$this->getForm();
	}

	public function edit() {
		$this->load->language('catalog/information');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('catalog/information');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->model_catalog_information->editInformation($this->request->get['information_id'], $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('catalog/information', 'user_token=' . $this->session->data['user_token'] . $url, true));
		}

		$this->getForm();
	}

	public function delete() {
		$this->load->language('catalog/information');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('catalog/information');

		if (isset($this->request->post['selected']) && $this->validateDelete()) {
			foreach ($this->request->post['selected'] as $information_id) {
				$this->model_catalog_information->deleteInformation($information_id);
			}

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('catalog/information', 'user_token=' . $this->session->data['user_token'] . $url, true));
		}

		$this->getList();
	}

	public function copy() {
		$this->load->language('catalog/information');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('catalog/information');

		if (isset($this->request->post['selected']) && $this->validateCopy()) {
			foreach ($this->request->post['selected'] as $information_id) {
				$this->model_catalog_information->copyInformation($information_id);
			}

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('catalog/information', 'user_token=' . $this->session->data['user_token'] . $url, true));
		}

		$this->getList();
	}

    protected function getList() {
		if (isset($this->request->get['filter_category'])) {
			$filter_category = $this->request->get['filter_category'];
		} else {
			$filter_category = '';
		}
     
		if (isset($this->request->get['filter_category_id'])) {
			$filter_category_id = $this->request->get['filter_category_id'];
		} else {
			$filter_category_id = '';
		}

		if (isset($this->request->get['filter_manufacturer'])) {
			$filter_manufacturer = $this->request->get['filter_manufacturer'];
		} else {
			$filter_manufacturer = '';
		}

		if (isset($this->request->get['filter_manufacturer_id'])) {
			$filter_manufacturer_id = $this->request->get['filter_manufacturer_id'];
		} else {
			$filter_manufacturer_id = '';
		}

		if (isset($this->request->get['filter_brand'])) {
			$filter_brand = $this->request->get['filter_brand'];
		} else {
			$filter_brand = '';
		}

		if (isset($this->request->get['filter_brand_id'])) {
			$filter_brand_id = $this->request->get['filter_brand_id'];
		} else {
			$filter_brand_id = '';
		}

        if (isset($this->request->get['sort'])) {
			$sort = $this->request->get['sort'];
		} else {
			$sort = 'id.title';
		}

		if (isset($this->request->get['order'])) {
			$order = $this->request->get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

		if (isset($this->request->get['filter_name'])) {
			$filter_name = $this->request->get['filter_name'];
		} else {
			$filter_name = '';
		}

		if (isset($this->request->get['filter_viewed'])) {
			$filter_viewed = $this->request->get['filter_viewed'];
		} else {
			$filter_viewed = '';
		}

		if (isset($this->request->get['filter_status'])) {
			$filter_status = $this->request->get['filter_status'];
		} else {
			$filter_status = '';
		}

		$url = '';
        
        if (isset($this->request->get['filter_category'])) {
            $url .= '&filter_category=' . urlencode(html_entity_decode($this->request->get['filter_category'], ENT_QUOTES, 'UTF-8'));
        }

        if (isset($this->request->get['filter_category_id'])) {
            $url .= '&filter_category_id=' . $this->request->get['filter_category_id'];
        }
        
        if (isset($this->request->get['filter_manufacturer'])) {
            $url .= '&filter_manufacturer=' . urlencode(html_entity_decode($this->request->get['filter_manufacturer'], ENT_QUOTES, 'UTF-8'));
        }
        
        if (isset($this->request->get['filter_manufacturer_id'])) {
            $url .= '&filter_manufacturer_id=' . $this->request->get['filter_manufacturer_id'];
        }

        if (isset($this->request->get['filter_brand'])) {
            $url .= '&filter_brand=' . urlencode(html_entity_decode($this->request->get['filter_brand'], ENT_QUOTES, 'UTF-8'));
        }
        
        if (isset($this->request->get['filter_brand_id'])) {
            $url .= '&filter_brand_id=' . $this->request->get['filter_brand_id'];
        }

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		if (isset($this->request->get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode($this->request->get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset($this->request->get['filter_viewed'])) {
			$url .= '&filter_viewed=' . urlencode(html_entity_decode($this->request->get['filter_viewed'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset($this->request->get['filter_status'])) {
			$url .= '&filter_status=' . $this->request->get['filter_status'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('catalog/information', 'user_token=' . $this->session->data['user_token'] . $url, true)
		);

		$data['add'] = $this->url->link('catalog/information/add', 'user_token=' . $this->session->data['user_token'] . $url, true);
		$data['delete'] = $this->url->link('catalog/information/delete', 'user_token=' . $this->session->data['user_token'] . $url, true);
        $data['copy'] = $this->url->link('catalog/information/copy', 'user_token=' . $this->session->data['user_token'] . $url, true);

		$data['informations'] = array();
        $data['viewbutton'] = array();

		$filter_data = array(
			'sort'  => $sort,
			'order' => $order,
			'filter_name'	=> $filter_name,
			'filter_viewed'	=> $filter_viewed,
			'filter_status' => $filter_status,
			'filter_category_id'	 => $filter_category_id,
			'filter_manufacturer_id' => $filter_manufacturer_id,
			'filter_brand_id' => $filter_brand_id,
			'start' => ($page - 1) * $this->config->get('config_limit_admin'),
			'limit' => $this->config->get('config_limit_admin')
		);

		$information_total = $this->model_catalog_information->getTotalInformations($filter_data);

		$this->load->model('tool/image');
		$this->load->model('catalog/category');
		$this->load->model('catalog/manufacturer');
		$this->load->model('catalog/brand');

		$data['user_token'] = $this->session->data['user_token'];

		$results = $this->model_catalog_information->getInformations($filter_data);

		foreach ($results as $result) {
			if (is_file(DIR_IMAGE . $result['image'])) {
				$image = $this->model_tool_image->resize($result['image'], 40, 40);
			} else {
				$image = $this->model_tool_image->resize('no_image.png', 40, 40);
			}

			$main_category = $this->model_catalog_information->getMainCategory($result['information_id']);

			$information_categories = array();

			$categories = $this->model_catalog_information->getInformationCategories($result['information_id']);

			if ($categories) {
				foreach ($categories as $category_id) {
					$category_info = $this->model_catalog_category->getCategory($category_id);

					if ($category_info) {
						$information_categories[] = array(
							'category_id' => $category_info['category_id'],
							'main'        => ($category_info['category_id'] == $main_category) ? true : '',
							'name'        => $category_info['path'] ? $category_info['path'] . ' &gt; ' . $category_info['name'] : $category_info['name']
						);
					}
				} 
			}

			$data['viewbutton'][$result['information_id']][] = array(
				'name' => $this->config->get('config_name'),
				'href' => HTTP_CATALOG . 'index.php?route=information/information&information_id=' . $result['information_id']
			);

			$this->load->model('setting/site');

			$results_site = $this->model_setting_site->getSites();
			foreach ($results_site as $site) {
				$data['viewbutton'][$result['information_id']][] = array( 
					'name' => $site['name'], 
					'href' => $site['url'] . 'index.php?route=information/information&information_id=' . $result['information_id']
				);
			}

            $data['informations'][] = array(
				'information_id' => $result['information_id'],
				'title'          => $result['title'],
				'sort_order'     => $result['sort_order'],
				'image'          => $image,
                'status'         => $result['status'] ? $this->language->get('text_enabled') : $this->language->get('text_disabled'),
				'viewed'         => $result['viewed'],
				'category'       => isset($result['category']) ? $result['category'] : '',
				'categories'     => $information_categories,
				'manufacturer'   => $result['manufacturer'],
				'brand'          => $result['brand'],
				'edit'           => $this->url->link('catalog/information/edit', 'user_token=' . $this->session->data['user_token'] . '&information_id=' . $result['information_id'] . $url, true)
			);
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset($this->request->post['selected'])) {
			$data['selected'] = (array)$this->request->post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data['sort_title'] = $this->url->link('catalog/information', 'user_token=' . $this->session->data['user_token'] . '&sort=id.title' . $url, true);
		$data['sort_sort_order'] = $this->url->link('catalog/information', 'user_token=' . $this->session->data['user_token'] . '&sort=i.sort_order' . $url, true);
		$data['sort_viewed'] = $this->url->link('catalog/information', 'user_token=' . $this->session->data['user_token'] . '&sort=i.viewed' . $url, true);
		$data['sort_status'] = $this->url->link('catalog/information', 'user_token=' . $this->session->data['user_token'] . '&sort=i.status' . $url, true);
		$data['sort_manufacturer'] = $this->url->link('catalog/information', 'user_token=' . $this->session->data['user_token'] . '&sort=manufacturer' . $url, true);
		$data['sort_brand'] = $this->url->link('catalog/information', 'user_token=' . $this->session->data['user_token'] . '&sort=brand' . $url, true);
		$data['sort_category'] = $this->url->link('catalog/information', 'user_token=' . $this->session->data['user_token'] . '&sort=category' . $url, true);

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		$pagination = new Pagination();
		$pagination->total = $information_total;
		$pagination->page = $page;
		$pagination->limit = $this->config->get('config_limit_admin');
		$pagination->url = $this->url->link('catalog/information', 'user_token=' . $this->session->data['user_token'] . $url . '&page={page}', true);

		$data['pagination'] = $pagination->render();

		$data['results'] = sprintf($this->language->get('text_pagination'), ($information_total) ? (($page - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($page - 1) * $this->config->get('config_limit_admin')) > ($information_total - $this->config->get('config_limit_admin'))) ? $information_total : ((($page - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $information_total, ceil($information_total / $this->config->get('config_limit_admin')));

		$data['sort'] = $sort;
		$data['order'] = $order;
		$data['filter_name'] = $filter_name;
		$data['filter_viewed'] = $filter_viewed;
		$data['filter_status'] = $filter_status;
		$data['filter_category'] = $filter_category;
		$data['filter_category_id'] = $filter_category_id;         
		$data['filter_manufacturer'] = $filter_manufacturer;
		$data['filter_manufacturer_id'] = $filter_manufacturer_id;
		$data['filter_brand'] = $filter_brand;
		$data['filter_brand_id'] = $filter_brand_id;

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('catalog/information_list', $data));
	}

	protected function getForm() {
		$data['text_form'] = !isset($this->request->get['information_id']) ? $this->language->get('text_add') : $this->language->get('text_edit');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['title'])) {
			$data['error_title'] = $this->error['title'];
		} else {
			$data['error_title'] = array();
		}

		if (isset($this->error['description'])) {
			$data['error_description'] = $this->error['description'];
		} else {
			$data['error_description'] = array();
		}

		if (isset($this->error['meta_title'])) {
			$data['error_meta_title'] = $this->error['meta_title'];
		} else {
			$data['error_meta_title'] = array();
		}

		if (isset($this->error['keyword'])) {
			$data['error_keyword'] = $this->error['keyword'];
		} else {
			$data['error_keyword'] = '';
		}

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('catalog/information', 'user_token=' . $this->session->data['user_token'] . $url, true)
		);

		if (!isset($this->request->get['information_id'])) {
			$data['action'] = $this->url->link('catalog/information/add', 'user_token=' . $this->session->data['user_token'] . $url, true);
		} else {
			$data['action'] = $this->url->link('catalog/information/edit', 'user_token=' . $this->session->data['user_token'] . '&information_id=' . $this->request->get['information_id'] . $url, true);
		}

		$data['cancel'] = $this->url->link('catalog/information', 'user_token=' . $this->session->data['user_token'] . $url, true);

		if (isset($this->request->get['information_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$information_info = $this->model_catalog_information->getInformation($this->request->get['information_id']);
		}

		$data['user_token'] = $this->session->data['user_token'];

		$this->load->model('localisation/language');

		$data['languages'] = $this->model_localisation_language->getLanguages();

		if (isset($this->request->post['information_description'])) {
			$data['information_description'] = $this->request->post['information_description'];
		} elseif (isset($this->request->get['information_id'])) {
			$data['information_description'] = $this->model_catalog_information->getInformationDescriptions($this->request->get['information_id']);
		} else {
			$data['information_description'] = array();
		}

        $this->load->model('setting/site');

		$data['sites'] = array();

		$data['sites'][] = array(
			'site_id' => 0,
			'name'     => $this->config->get('config_name')
		);

		$sites = $this->model_setting_site->getSites();

		foreach ($sites as $site) {
			$data['sites'][] = array(
				'site_id' => $site['site_id'],
				'name'     => $site['name']
			);
		}

		if (isset($this->request->post['information_site'])) {
			$data['information_site'] = $this->request->post['information_site'];
		} elseif (isset($this->request->get['information_id'])) {
			$data['information_site'] = $this->model_catalog_information->getInformationSites($this->request->get['information_id']);
		} else {
			$data['information_site'] = array(0);
		}

		if (isset($this->request->get['information_id'])) {
			$data['information_id'] = $this->request->get['information_id'];
		}

		if (isset($this->request->post['date_available'])) {
			$data['date_available'] = $this->request->post['date_available'];
		} elseif (!empty($information_info)) {
			$data['date_available'] = $information_info['date_available'];
		} else {
			$data['date_available'] = date('Y-m-d H:i:s');
		}

		if (isset($this->request->post['date_end'])) {
			$data['date_end'] = $this->request->post['date_end'];
		} elseif (!empty($information_info)) {
			$data['date_end'] = $information_info['date_end'];
		} else {
			$data['date_end'] = '2100-01-01 00:00:00';
		}

		if (isset($this->request->post['date_added'])) {
			$data['date_added'] = $this->request->post['date_added'];
		} elseif (!empty($information_info)) {
			$data['date_added'] = $information_info['date_added'];
		} else {
			$data['date_added'] = date('Y-m-d H:i:s');
		}

        if (isset($this->request->post['bottom'])) {
			$data['bottom'] = $this->request->post['bottom'];
		} elseif (!empty($information_info)) {
			$data['bottom'] = $information_info['bottom'];
		} else {
			$data['bottom'] = 0;
		}

		if (isset($this->request->post['status'])) {
			$data['status'] = $this->request->post['status'];
		} elseif (!empty($information_info)) {
			$data['status'] = $information_info['status'];
		} else {
			$data['status'] = true;
		}

		if (isset($this->request->post['sort_order'])) {
			$data['sort_order'] = $this->request->post['sort_order'];
		} elseif (!empty($information_info)) {
			$data['sort_order'] = $information_info['sort_order'];
		} else {
			$data['sort_order'] = '';
		}

		// User
		$this->load->model('user/user');
		$this->load->model('user/user_group');

		$user_groups = $this->model_user_user_group->getUserGroups();

		foreach ($user_groups as $group) {
			$users = array();

			$users = $this->model_user_user->getUsersByGroup($group['user_group_id']);

			if ($users) {
				$data['user_groups'][] = array(
					'name'  => $group['name'],
					'users' => $users
				);
			}
		}

		if (isset($this->request->post['user_id'])) {
			$data['user_id'] = $this->request->post['user_id'];
		} elseif (!empty($information_info)) {
			$data['user_id'] = $this->model_catalog_information->getInformationUser($this->request->get['information_id']);
		} else {
			$data['user_id'] = $this->user->getId();
		}
/*
		// User from team
		$this->load->model('catalog/team');
		$this->load->model('catalog/team_group');

		$team_groups = $this->model_catalog_team_group->getTeamGroups();

		foreach ($team_groups as $group) {
			$teams = array();

			$teams = $this->model_catalog_team->getTeamsByGroup($group['team_group_id']);

			if ($teams) {
				$data['team_groups'][] = array(
					'name'  => $group['name'],
					'teams' => $teams
				);
			}
		}

		if (isset($this->request->post['team_id'])) {
			$data['team_id'] = $this->request->post['team_id'];
		} elseif (!empty($information_info)) {
			$data['team_id'] = $this->model_catalog_information->getInformationTeam($this->request->get['information_id']);
		} else {
			$data['team_id'] = $this->team->getId();
		}
*/
		// Manufacturer
		$this->load->model('catalog/manufacturer');

		if (isset($this->request->post['manufacturer_id'])) {
			$data['manufacturer_id'] = $this->request->post['manufacturer_id'];
		} elseif (!empty($information_info)) {
			$data['manufacturer_id'] = $information_info['manufacturer_id'];
		} else {
			$data['manufacturer_id'] = 0;
		}

		if (isset($this->request->post['manufacturer'])) {
			$data['manufacturer'] = $this->request->post['manufacturer'];
		} elseif (!empty($information_info)) {
			$manufacturer_info = $this->model_catalog_manufacturer->getManufacturer($information_info['manufacturer_id']);

			if ($manufacturer_info) {
				$data['manufacturer'] = $manufacturer_info['name'];
			} else {
				$data['manufacturer'] = '';
			}
		} else {
			$data['manufacturer'] = '';
		}

		// Brand
		$this->load->model('catalog/brand');

		if (isset($this->request->post['brand_id'])) {
			$data['brand_id'] = $this->request->post['brand_id'];
		} elseif (!empty($information_info)) {
			$data['brand_id'] = $information_info['brand_id'];
		} else {
			$data['brand_id'] = 0;
		}

		if (isset($this->request->post['brand'])) {
			$data['brand'] = $this->request->post['brand'];
		} elseif (!empty($information_info)) {
			$brand_info = $this->model_catalog_brand->getBrand($information_info['brand_id']);

			if ($brand_info) {
				$data['brand'] = $brand_info['name'];
			} else {
				$data['brand'] = '';
			}
		} else {
			$data['brand'] = '';
		}

		// Categories
		$this->load->model('catalog/category');

		if (isset($this->request->post['information_category'])) {
			$categories = $this->request->post['information_category'];
		} elseif (isset($this->request->get['information_id'])) {
			$categories = $this->model_catalog_information->getInformationCategories($this->request->get['information_id']);
		} else {
			$categories = array();
		}

// use checkbox for select categories
/*		if ($categories) {
            $data['categories_tree'] = $categories_tree;

            $filter = array(
                'sort'        => 'name',
                'order'       => 'ASC',
            );
        
            $results = $this->model_catalog_category->getCategories($filter);
            foreach ($results as $result) {
                $check = '';
                if (in_array($result['category_id'], $categories)) {
                    $check = 'checked';
                }
                $categories_tree[] = array(
                    'category_id'   => $result['category_id'],
                    'name'          => strip_tags(html_entity_decode($result['name'], ENT_QUOTES, 'UTF-8')),
                    'check'         => $check
                );
            }
		}
*/
// end trees

        $data['information_categories'] = array();

		foreach ($categories as $category_id) {
			$category_info = $this->model_catalog_category->getCategory($category_id);

			if ($category_info) {
				$data['information_categories'][] = array(
					'category_id' => $category_info['category_id'],
					'name'        => ($category_info['path']) ? $category_info['path'] . ' &gt; ' . $category_info['name'] : $category_info['name']
				);
			}
		}

		if (isset($this->request->post['main_category'])) {
			$data['main_category'] = $this->request->post['main_category'];
		} elseif (isset($this->request->get['information_id']) && $categories) {
			$data['main_category'] = $this->model_catalog_information->getMainCategory($this->request->get['information_id']);
		} else {
			$data['main_category'] = '';
		}

		// Attributes
		$this->load->model('catalog/attribute');

		if (isset($this->request->post['information_attribute'])) {
			$information_attributes = $this->request->post['information_attribute'];
		} elseif (isset($this->request->get['information_id'])) {
			$information_attributes = $this->model_catalog_information->getInformationAttributes($this->request->get['information_id']);
		} else {
			$information_attributes = array();
		}

		$data['information_attributes'] = array();

		foreach ($information_attributes as $information_attribute) {
			$attribute_info = $this->model_catalog_attribute->getAttribute($information_attribute['attribute_id']);

			if ($attribute_info) {
				$data['information_attributes'][] = array(
					'attribute_id'                  => $information_attribute['attribute_id'],
					'name'                          => $attribute_info['name'],
					'information_attribute_description' => $information_attribute['information_attribute_description']
				);
			}
		}

		// Image
		if (isset($this->request->post['image'])) {
			$data['image'] = $this->request->post['image'];
		} elseif (!empty($information_info)) {
			$data['image'] = $information_info['image'];
		} else {
			$data['image'] = '';
		}

		$this->load->model('tool/image');

		if (isset($this->request->post['image']) && is_file(DIR_IMAGE . $this->request->post['image'])) {
			$data['thumb'] = $this->model_tool_image->resize($this->request->post['image'], 100, 100);
		} elseif (!empty($information_info) && is_file(DIR_IMAGE . $information_info['image'])) {
			$data['thumb'] = $this->model_tool_image->resize($information_info['image'], 100, 100);
		} else {
			$data['thumb'] = $this->model_tool_image->resize('no_image.png', 100, 100);
		}

		$data['placeholder'] = $this->model_tool_image->resize('no_image.png', 100, 100);

		// Images
		if (isset($this->request->post['information_image'])) {
			$information_images = $this->request->post['information_image'];
		} elseif (isset($this->request->get['information_id'])) {
			$information_images = $this->model_catalog_information->getInformationImages($this->request->get['information_id']);
		} else {
			$information_images = array();
		}

		$data['information_images'] = array();

		foreach ($information_images as $information_image) {
			if (is_file(DIR_IMAGE . $information_image['image'])) {
				$image = $information_image['image'];
				$thumb = $information_image['image'];
			} else {
				$image = '';
				$thumb = 'no_image.png';
			}

			$data['information_images'][] = array(
				'image'      => $image,
				'thumb'      => $this->model_tool_image->resize($thumb, 100, 100),
				'sort_order' => $information_image['sort_order']
			);
		}

        // Information Related
		if (isset($this->request->post['information_related'])) {
			$informations = $this->request->post['information_related'];
		} elseif (isset($this->request->get['information_id'])) {
			$informations = $this->model_catalog_information->getInformationRelated($this->request->get['information_id']);
		} else {
			$informations = array();
		}

		$data['information_relateds'] = array();

		foreach ($informations as $information_related) {
			$related_info = $this->model_catalog_information->getInformation($information_related['information_id']);

			if ($related_info) {
				$data['information_relateds'][] = array(
					'information_id' => $related_info['information_id'],
					'title'          => $related_info['title'],
                    'route'          => $information_related['route']
				);
			}
		}
        
        if (isset($this->request->post['information_seo_url'])) {
			$data['information_seo_url'] = $this->request->post['information_seo_url'];
		} elseif (isset($this->request->get['information_id'])) {
			$data['information_seo_url'] = $this->model_catalog_information->getInformationSeoUrls($this->request->get['information_id']);
		} else {
			$data['information_seo_url'] = array();
		}

		if (isset($this->request->post['information_layout'])) {
			$data['information_layout'] = $this->request->post['information_layout'];
		} elseif (isset($this->request->get['information_id'])) {
			$data['information_layout'] = $this->model_catalog_information->getInformationLayouts($this->request->get['information_id']);
		} else {
			$data['information_layout'] = array();
		}

		$this->load->model('design/layout');

		$data['layouts'] = $this->model_design_layout->getLayouts();

        if (isset($this->request->post['information_document'])) {
            $information_documents = $this->request->post['information_document'];
        } elseif (isset($this->request->get['information_id'])) {
            $information_documents = $this->model_catalog_information->getInformationDocuments($this->request->get['information_id']);
        } else {
            $information_documents = array();
        }

        $data['information_documents'] = array();

        foreach ($information_documents as $information_document) {
            $data['information_documents'][] = array(
                'document'      => $information_document['document'],
                'sort_order'    => $information_document['sort_order'],
                'document_name' => $information_document['document_name']
            );
        }

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('catalog/information_form', $data));
	}

	protected function validateCopy() {
		if (!$this->user->hasPermission('modify', 'catalog/information')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}

	public function upload() {
		$this->load->language('catalog/information');

		$json = array();

		if (!$json) {
			if (!empty($this->request->files['file']['name']) && is_file($this->request->files['file']['tmp_name'])) {
				// Sanitize the filename
				$filename = basename(html_entity_decode($this->request->files['file']['name'], ENT_QUOTES, 'UTF-8'));

				// Validate the filename length
				if ((utf8_strlen($filename) < 3) || (utf8_strlen($filename) > 128)) {
					$json['error'] = $this->language->get('error_filename');
				}

				// Allowed file extension types
				$allowed = array();

				$extension_allowed = preg_replace('~\r?\n~', "\n", $this->config->get('config_file_ext_allowed'));

				$filetypes = explode("\n", $extension_allowed);

				foreach ($filetypes as $filetype) {
					$allowed[] = trim($filetype);
				}

				if (!in_array(strtolower(substr(strrchr($filename, '.'), 1)), $allowed)) {
					$json['error'] = $this->language->get('error_filetype');
				}

				// Allowed file mime types
				$allowed = array();

				$mime_allowed = preg_replace('~\r?\n~', "\n", $this->config->get('config_file_mime_allowed'));

				$filetypes = explode("\n", $mime_allowed);

				foreach ($filetypes as $filetype) {
					$allowed[] = trim($filetype);
				}

				if (!in_array($this->request->files['file']['type'], $allowed)) {
					$json['error'] = $this->language->get('error_filetype');
				}

				// Check to see if any PHP files are trying to be uploaded
				$content = file_get_contents($this->request->files['file']['tmp_name']);

				if (preg_match('/\<\?php/i', $content)) {
					$json['error'] = $this->language->get('error_filetype');
				}

				// Return any upload error
				if ($this->request->files['file']['error'] != UPLOAD_ERR_OK) {
					$json['error'] = $this->language->get('error_upload_' . $this->request->files['file']['error']);
				}
			} else {
				$json['error'] = $this->language->get('error_upload');
			}
		}

		if (!$json) {
            $file = $filename;

			move_uploaded_file($this->request->files['file']['tmp_name'], DIR_DOWNLOAD . $file);

			$json['filename'] = $file;

			$json['success'] = $this->language->get('text_upload');
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}

	public function autocomplete() {
		$json = array();

		if (isset($this->request->get['filter_name'])) {
			$this->load->model('catalog/information');

			if (isset($this->request->get['filter_name'])) {
				$filter_name = $this->request->get['filter_name'];
			} else {
				$filter_name = '';
			}

			if (isset($this->request->get['limit'])) {
				$limit = $this->request->get['limit'];
			} else {
				$limit = 15;
			}

			$filter_data = array(
				'filter_name'  => $filter_name,
				'start'        => 0,
				'limit'        => $limit
			);

			$results = $this->model_catalog_information->getInformations($filter_data);

			foreach ($results as $result) {
				if (isset($this->request->get['information_id']) && $this->request->get['information_id'] == $result['information_id']) {
					continue;
				}
        
				$json[] = array(
					'information_id' => $result['information_id'],
					'title'          => strip_tags(html_entity_decode($result['title'], ENT_QUOTES, 'UTF-8'))
				);	
			}
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}

    protected function validateForm() {
		if (!$this->user->hasPermission('modify', 'catalog/information')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		foreach ($this->request->post['information_description'] as $language_id => $value) {
			if ((utf8_strlen($value['title']) < 1) || (utf8_strlen($value['title']) > 64)) {
				$this->error['title'][$language_id] = $this->language->get('error_title');
			}

			if (utf8_strlen($value['description']) < 3) {
				$this->error['description'][$language_id] = $this->language->get('error_description');
			}

			if ((utf8_strlen($value['meta_title']) < 1) || (utf8_strlen($value['meta_title']) > 100)) {
				$this->error['meta_title'][$language_id] = $this->language->get('error_meta_title');
			}
		}

		if ($this->request->post['information_seo_url']) {
			$this->load->model('design/seo_url');

			foreach ($this->request->post['information_seo_url'] as $site_id => $language) {
				foreach ($language as $language_id => $keyword) {
					if (!empty($keyword)) {
						if (count(array_keys($language, $keyword)) > 1) {
							$this->error['keyword'][$site_id][$language_id] = $this->language->get('error_unique');
						}

						$seo_urls = $this->model_design_seo_url->getSeoUrlsByKeyword($keyword);

						foreach ($seo_urls as $seo_url) {
							if (($seo_url['site_id'] == $site_id) && (!isset($this->request->get['information_id']) || ($seo_url['query'] != 'information_id=' . $this->request->get['information_id']))) {
								$this->error['keyword'][$site_id][$language_id] = $this->language->get('error_keyword');

								break;
							}
						}
					}
				}
			}
        }

		if ($this->error && !isset($this->error['warning'])) {
			$this->error['warning'] = $this->language->get('error_warning');
		}

		return !$this->error;
	}

	protected function validateDelete() {
		if (!$this->user->hasPermission('modify', 'catalog/information')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		$this->load->model('setting/site');

		foreach ($this->request->post['selected'] as $information_id) {
			if ($this->config->get('config_account_id') == $information_id) {
				$this->error['warning'] = $this->language->get('error_account');
			}

			$site_total = $this->model_setting_site->getTotalSitesByInformationId($information_id);

			if ($site_total) {
				$this->error['warning'] = sprintf($this->language->get('error_site'), $site_total);
			}
		}

        return !$this->error;
	}
}