<?php
class ControllerExtensionThemeDefault extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/theme/default');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('theme_default', $this->request->post, $this->request->get['site_id']);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=theme', true));
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['information_limit'])) {
			$data['error_information_limit'] = $this->error['information_limit'];
		} else {
			$data['error_information_limit'] = '';
		}

		if (isset($this->error['information_description_length'])) {
			$data['error_information_description_length'] = $this->error['information_description_length'];
		} else {
			$data['error_information_description_length'] = '';
		}

		if (isset($this->error['image_category'])) {
			$data['error_image_category'] = $this->error['image_category'];
		} else {
			$data['error_image_category'] = '';
		}

		if (isset($this->error['image_subcategory'])) {
			$data['error_image_subcategory'] = $this->error['image_subcategory'];
		} else {
			$data['error_image_subcategory'] = '';
		}

		if (isset($this->error['image_team'])) {
			$data['error_image_team'] = $this->error['image_team'];
		} else {
			$data['error_image_team'] = '';
		}

		if (isset($this->error['image_manufacturer'])) {
			$data['error_image_manufacturer'] = $this->error['image_manufacturer'];
		} else {
			$data['error_image_manufacturer'] = '';
		}

		if (isset($this->error['image_brand'])) {
			$data['error_image_brand'] = $this->error['image_brand'];
		} else {
			$data['error_image_brand'] = '';
		}

		if (isset($this->error['image_thumb'])) {
			$data['error_image_thumb'] = $this->error['image_thumb'];
		} else {
			$data['error_image_thumb'] = '';
		}

		if (isset($this->error['image_popup'])) {
			$data['error_image_popup'] = $this->error['image_popup'];
		} else {
			$data['error_image_popup'] = '';
		}

		if (isset($this->error['image_information'])) {
			$data['error_image_information'] = $this->error['image_information'];
		} else {
			$data['error_image_information'] = '';
		}

		if (isset($this->error['image_additional'])) {
			$data['error_image_additional'] = $this->error['image_additional'];
		} else {
			$data['error_image_additional'] = '';
		}

		if (isset($this->error['image_related'])) {
			$data['error_image_related'] = $this->error['image_related'];
		} else {
			$data['error_image_related'] = '';
		}

        if (isset($this->error['image_location'])) {
			$data['error_image_location'] = $this->error['image_location'];
		} else {
			$data['error_image_location'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=theme', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/theme/default', 'user_token=' . $this->session->data['user_token'] . '&site_id=' . $this->request->get['site_id'], true)
		);

		$data['action'] = $this->url->link('extension/theme/default', 'user_token=' . $this->session->data['user_token'] . '&site_id=' . $this->request->get['site_id'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=theme', true);

		if (isset($this->request->get['site_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$setting_info = $this->model_setting_setting->getSetting('theme_default', $this->request->get['site_id']);
		}

		if (isset($this->request->post['theme_default_directory'])) {
			$data['theme_default_directory'] = $this->request->post['theme_default_directory'];
		} elseif (isset($setting_info['theme_default_directory'])) {
			$data['theme_default_directory'] = $setting_info['theme_default_directory'];
		} else {
			$data['theme_default_directory'] = 'default';
		}

		$data['directories'] = array();

		$directories = glob(DIR_CATALOG . 'view/theme/*', GLOB_ONLYDIR);

		foreach ($directories as $directory) {
			$data['directories'][] = basename($directory);
		}

		if (isset($this->request->post['theme_default_status'])) {
			$data['theme_default_status'] = $this->request->post['theme_default_status'];
		} elseif (isset($setting_info['theme_default_status'])) {
			$data['theme_default_status'] = $setting_info['theme_default_status'];
		} else {
			$data['theme_default_status'] = '';
		}

		if (isset($this->request->post['theme_default_information_limit'])) {
			$data['theme_default_information_limit'] = $this->request->post['theme_default_information_limit'];
		} elseif (isset($setting_info['theme_default_information_limit'])) {
			$data['theme_default_information_limit'] = $setting_info['theme_default_information_limit'];
		} else {
			$data['theme_default_information_limit'] = 15;
		}

		if (isset($this->request->post['theme_default_information_description_length'])) {
			$data['theme_default_information_description_length'] = $this->request->post['theme_default_information_description_length'];
		} elseif (isset($setting_info['theme_default_information_description_length'])) {
			$data['theme_default_information_description_length'] = $setting_info['theme_default_information_description_length'];
		} else {
			$data['theme_default_information_description_length'] = 140;
		}

		if (isset($this->request->post['theme_default_social_code'])) {
			$data['theme_default_social_code'] = $this->request->post['theme_default_social_code'];
		} elseif (isset($setting_info['theme_default_social_code'])) {
			$data['theme_default_social_code'] = $setting_info['theme_default_social_code'];
		} else {
			$data['theme_default_social_code'] = '';
		}

		if (isset($this->request->post['theme_default_social_share_toolbox'])) {
			$data['theme_default_social_share_toolbox'] = $this->request->post['theme_default_social_share_toolbox'];
		} elseif (isset($setting_info['theme_default_social_share_toolbox'])) {
			$data['theme_default_social_share_toolbox'] = $setting_info['theme_default_social_share_toolbox'];
		} else {
			$data['theme_default_social_share_toolbox'] = '';
		}

		if (isset($this->request->post['theme_default_social_share_status'])) {
			$data['theme_default_social_share_status'] = $this->request->post['theme_default_social_share_status'];
		} elseif (isset($setting_info['theme_default_social_share_status'])) {
			$data['theme_default_social_share_status'] = $setting_info['theme_default_social_share_status'];
		} else {
			$data['theme_default_social_share_status'] = '';
		}

		if (isset($this->request->post['theme_default_social_follow_status'])) {
			$data['theme_default_social_follow_status'] = $this->request->post['theme_default_social_follow_status'];
		} elseif (isset($setting_info['theme_default_social_follow_status'])) {
			$data['theme_default_social_follow_status'] = $setting_info['theme_default_social_follow_status'];
		} else {
			$data['theme_default_social_follow_status'] = '';
		}

		if (isset($this->request->post['theme_default_team_menu'])) {
			$data['theme_default_team_menu'] = $this->request->post['theme_default_team_menu'];
		} elseif (isset($setting_info['theme_default_team_menu'])) {
			$data['theme_default_team_menu'] = $setting_info['theme_default_team_menu'];
		} else {
			$data['theme_default_team_menu'] = 1;
		}		

		if (isset($this->request->post['theme_default_team_footer'])) {
			$data['theme_default_team_footer'] = $this->request->post['theme_default_team_footer'];
		} elseif (isset($setting_info['theme_default_team_footer'])) {
			$data['theme_default_team_footer'] = $setting_info['theme_default_team_footer'];
		} else {
			$data['theme_default_team_footer'] = 1;
		}		

		if (isset($this->request->post['theme_default_manufacturer_menu'])) {
			$data['theme_default_manufacturer_menu'] = $this->request->post['theme_default_manufacturer_menu'];
		} elseif (isset($setting_info['theme_default_manufacturer_menu'])) {
			$data['theme_default_manufacturer_menu'] = $setting_info['theme_default_manufacturer_menu'];
		} else {
			$data['theme_default_manufacturer_menu'] = 1;
		}		

		if (isset($this->request->post['theme_default_manufacturer_footer'])) {
			$data['theme_default_manufacturer_footer'] = $this->request->post['theme_default_manufacturer_footer'];
		} elseif (isset($setting_info['theme_default_manufacturer_footer'])) {
			$data['theme_default_manufacturer_footer'] = $setting_info['theme_default_manufacturer_footer'];
		} else {
			$data['theme_default_manufacturer_footer'] = 1;
		}		

		if (isset($this->request->post['theme_default_brand_menu'])) {
			$data['theme_default_brand_menu'] = $this->request->post['theme_default_brand_menu'];
		} elseif (isset($setting_info['theme_default_brand_menu'])) {
			$data['theme_default_brand_menu'] = $setting_info['theme_default_brand_menu'];
		} else {
			$data['theme_default_brand_menu'] = 1;
		}		

		if (isset($this->request->post['theme_default_brand_footer'])) {
			$data['theme_default_brand_footer'] = $this->request->post['theme_default_brand_footer'];
		} elseif (isset($setting_info['theme_default_brand_footer'])) {
			$data['theme_default_brand_footer'] = $setting_info['theme_default_brand_footer'];
		} else {
			$data['theme_default_brand_footer'] = 1;
		}		

		if (isset($this->request->post['theme_default_webshop_footer'])) {
			$data['theme_default_webshop_footer'] = $this->request->post['theme_default_webshop_footer'];
		} elseif (isset($setting_info['theme_default_webshop_footer'])) {
			$data['theme_default_webshop_footer'] = $setting_info['theme_default_webshop_footer'];
		} else {
			$data['theme_default_webshop_footer'] = 1;
		}		

		if (isset($this->request->post['theme_default_image_category_width'])) {
			$data['theme_default_image_category_width'] = $this->request->post['theme_default_image_category_width'];
		} elseif (isset($setting_info['theme_default_image_category_width'])) {
			$data['theme_default_image_category_width'] = $setting_info['theme_default_image_category_width'];
		} else {
			$data['theme_default_image_category_width'] = 360;
		}

		if (isset($this->request->post['theme_default_image_category_height'])) {
			$data['theme_default_image_category_height'] = $this->request->post['theme_default_image_category_height'];
		} elseif (isset($setting_info['theme_default_image_category_height'])) {
			$data['theme_default_image_category_height'] = $setting_info['theme_default_image_category_height'];
		} else {
			$data['theme_default_image_category_height'] = 240;
		}

		if (isset($this->request->post['theme_default_image_subcategory_width'])) {
			$data['theme_default_image_subcategory_width'] = $this->request->post['theme_default_image_subcategory_width'];
		} elseif (isset($setting_info['theme_default_image_subcategory_width'])) {
			$data['theme_default_image_subcategory_width'] = $setting_info['theme_default_image_subcategory_width'];
		} else {
			$data['theme_default_image_subcategory_width'] = 120;
		}

		if (isset($this->request->post['theme_default_image_subcategory_height'])) {
			$data['theme_default_image_subcategory_height'] = $this->request->post['theme_default_image_subcategory_height'];
		} elseif (isset($setting_info['theme_default_image_subcategory_height'])) {
			$data['theme_default_image_subcategory_height'] = $setting_info['theme_default_image_subcategory_height'];
		} else {
			$data['theme_default_image_subcategory_height'] = 80;
		}

		if (isset($this->request->post['theme_default_image_team_width'])) {
			$data['theme_default_image_team_width'] = $this->request->post['theme_default_image_team_width'];
		} elseif (isset($setting_info['theme_default_image_team_width'])) {
			$data['theme_default_image_team_width'] = $setting_info['theme_default_image_team_width'];
		} else {
			$data['theme_default_image_team_width'] = 180;
		} 

		if (isset($this->request->post['theme_default_image_team_height'])) {
			$data['theme_default_image_team_height'] = $this->request->post['theme_default_image_team_height'];
		} elseif (isset($setting_info['theme_default_image_team_height'])) {
			$data['theme_default_image_team_height'] = $setting_info['theme_default_image_team_height'];
		} else {
			$data['theme_default_image_team_height'] = 180;
		}

		if (isset($this->request->post['theme_default_image_manufacturer_width'])) {
			$data['theme_default_image_manufacturer_width'] = $this->request->post['theme_default_image_manufacturer_width'];
		} elseif (isset($setting_info['theme_default_image_manufacturer_width'])) {
			$data['theme_default_image_manufacturer_width'] = $setting_info['theme_default_image_manufacturer_width'];
		} else {
			$data['theme_default_image_manufacturer_width'] = 310;
		} 

		if (isset($this->request->post['theme_default_image_manufacturer_height'])) {
			$data['theme_default_image_manufacturer_height'] = $this->request->post['theme_default_image_manufacturer_height'];
		} elseif (isset($setting_info['theme_default_image_manufacturer_height'])) {
			$data['theme_default_image_manufacturer_height'] = $setting_info['theme_default_image_manufacturer_height'];
		} else {
			$data['theme_default_image_manufacturer_height'] = 66;
		}

		if (isset($this->request->post['theme_default_image_brand_width'])) {
			$data['theme_default_image_brand_width'] = $this->request->post['theme_default_image_brand_width'];
		} elseif (isset($setting_info['theme_default_image_brand_width'])) {
			$data['theme_default_image_brand_width'] = $setting_info['theme_default_image_brand_width'];
		} else {
			$data['theme_default_image_brand_width'] = 310;
		} 

		if (isset($this->request->post['theme_default_image_brand_height'])) {
			$data['theme_default_image_brand_height'] = $this->request->post['theme_default_image_brand_height'];
		} elseif (isset($setting_info['theme_default_image_brand_height'])) {
			$data['theme_default_image_brand_height'] = $setting_info['theme_default_image_brand_height'];
		} else {
			$data['theme_default_image_brand_height'] = 66;
		}

        if (isset($this->request->post['theme_default_image_thumb_width'])) {
			$data['theme_default_image_thumb_width'] = $this->request->post['theme_default_image_thumb_width'];
		} elseif (isset($setting_info['theme_default_image_thumb_width'])) {
			$data['theme_default_image_thumb_width'] = $setting_info['theme_default_image_thumb_width'];
		} else {
			$data['theme_default_image_thumb_width'] = 846;
		}
		
		if (isset($this->request->post['theme_default_image_thumb_height'])) {
			$data['theme_default_image_thumb_height'] = $this->request->post['theme_default_image_thumb_height'];
		} elseif (isset($setting_info['theme_default_image_thumb_height'])) {
			$data['theme_default_image_thumb_height'] = $setting_info['theme_default_image_thumb_height'];
		} else {
			$data['theme_default_image_thumb_height'] = 282;		
		}
		
		if (isset($this->request->post['theme_default_image_popup_width'])) {
			$data['theme_default_image_popup_width'] = $this->request->post['theme_default_image_popup_width'];
		} elseif (isset($setting_info['theme_default_image_popup_width'])) {
			$data['theme_default_image_popup_width'] = $setting_info['theme_default_image_popup_width'];
		} else {
			$data['theme_default_image_popup_width'] = 1140;
		}
		
		if (isset($this->request->post['theme_default_image_popup_height'])) {
			$data['theme_default_image_popup_height'] = $this->request->post['theme_default_image_popup_height'];
		} elseif (isset($setting_info['theme_default_image_popup_height'])) {
			$data['theme_default_image_popup_height'] = $setting_info['theme_default_image_popup_height'];
		} else {
			$data['theme_default_image_popup_height'] = 380;
		}
		
		if (isset($this->request->post['theme_default_image_information_width'])) {
			$data['theme_default_image_information_width'] = $this->request->post['theme_default_image_information_width'];
		} elseif (isset($setting_info['theme_default_image_information_width'])) {
			$data['theme_default_image_information_width'] = $setting_info['theme_default_image_information_width'];
		} else {
			$data['theme_default_image_information_width'] = 360;
		}
		
		if (isset($this->request->post['theme_default_image_information_height'])) {
			$data['theme_default_image_information_height'] = $this->request->post['theme_default_image_information_height'];
		} elseif (isset($setting_info['theme_default_image_information_height'])) {
			$data['theme_default_image_information_height'] = $setting_info['theme_default_image_information_height'];
		} else {
			$data['theme_default_image_information_height'] = 180;
		}
		
		if (isset($this->request->post['theme_default_image_additional_width'])) {
			$data['theme_default_image_additional_width'] = $this->request->post['theme_default_image_additional_width'];
		} elseif (isset($setting_info['theme_default_image_additional_width'])) {
			$data['theme_default_image_additional_width'] = $setting_info['theme_default_image_additional_width'];
		} else {
			$data['theme_default_image_additional_width'] = 260;
		}
		
		if (isset($this->request->post['theme_default_image_additional_height'])) {
			$data['theme_default_image_additional_height'] = $this->request->post['theme_default_image_additional_height'];
		} elseif (isset($setting_info['theme_default_image_additional_height'])) {
			$data['theme_default_image_additional_height'] = $setting_info['theme_default_image_additional_height'];
		} else {
			$data['theme_default_image_additional_height'] = 87;
		}
		
		if (isset($this->request->post['theme_default_image_related_width'])) {
			$data['theme_default_image_related_width'] = $this->request->post['theme_default_image_related_width'];
		} elseif (isset($setting_info['theme_default_image_related_width'])) {
			$data['theme_default_image_related_width'] = $setting_info['theme_default_image_related_width'];
		} else {
			$data['theme_default_image_related_width'] = 260;
		}
		
		if (isset($this->request->post['theme_default_image_related_height'])) {
			$data['theme_default_image_related_height'] = $this->request->post['theme_default_image_related_height'];
		} elseif (isset($setting_info['theme_default_image_related_height'])) {
			$data['theme_default_image_related_height'] = $setting_info['theme_default_image_related_height'];
		} else {
			$data['theme_default_image_related_height'] = 87;
		}

		if (isset($this->request->post['theme_default_image_location_width'])) {
			$data['theme_default_image_location_width'] = $this->request->post['theme_default_image_location_width'];
		} elseif (isset($setting_info['theme_default_image_location_width'])) {
			$data['theme_default_image_location_width'] = $setting_info['theme_default_image_location_width'];
		} else {
			$data['theme_default_image_location_width'] = 268;
		}

		if (isset($this->request->post['theme_default_image_location_height'])) {
			$data['theme_default_image_location_height'] = $this->request->post['theme_default_image_location_height'];
		} elseif (isset($setting_info['theme_default_image_location_height'])) {
			$data['theme_default_image_location_height'] = $setting_info['theme_default_image_location_height'];
		} else {
			$data['theme_default_image_location_height'] = 50;
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/theme/default', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/theme/default')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['theme_default_information_limit']) {
			$this->error['information_limit'] = $this->language->get('error_limit');
		}

		if (!$this->request->post['theme_default_information_description_length']) {
			$this->error['information_description_length'] = $this->language->get('error_limit');
		}

		if (!$this->request->post['theme_default_image_category_width'] || !$this->request->post['theme_default_image_category_height']) {
			$this->error['image_category'] = $this->language->get('error_image_category');
		}

		if (!$this->request->post['theme_default_image_subcategory_width'] || !$this->request->post['theme_default_image_subcategory_height']) {
			$this->error['image_subcategory'] = $this->language->get('error_image_subcategory');
		}

		if (!$this->request->post['theme_default_image_team_width'] || !$this->request->post['theme_default_image_team_height']) {
			$this->error['image_team'] = $this->language->get('error_image_team');
		}

		if (!$this->request->post['theme_default_image_manufacturer_width'] || !$this->request->post['theme_default_image_manufacturer_height']) {
			$this->error['image_manufacturer'] = $this->language->get('error_image_manufacturer');
		}

		if (!$this->request->post['theme_default_image_brand_width'] || !$this->request->post['theme_default_image_brand_height']) {
			$this->error['image_brand'] = $this->language->get('error_image_brand');
		}

		if (!$this->request->post['theme_default_image_thumb_width'] || !$this->request->post['theme_default_image_thumb_height']) {
			$this->error['image_thumb'] = $this->language->get('error_image_thumb');
		}

		if (!$this->request->post['theme_default_image_popup_width'] || !$this->request->post['theme_default_image_popup_height']) {
			$this->error['image_popup'] = $this->language->get('error_image_popup');
		}

		if (!$this->request->post['theme_default_image_information_width'] || !$this->request->post['theme_default_image_information_height']) {
			$this->error['image_information'] = $this->language->get('error_image_information');
		}

		if (!$this->request->post['theme_default_image_additional_width'] || !$this->request->post['theme_default_image_additional_height']) {
			$this->error['image_additional'] = $this->language->get('error_image_additional');
		}

		if (!$this->request->post['theme_default_image_related_width'] || !$this->request->post['theme_default_image_related_height']) {
			$this->error['image_related'] = $this->language->get('error_image_related');
		}

        if (!$this->request->post['theme_default_image_location_width'] || !$this->request->post['theme_default_image_location_height']) {
			$this->error['image_location'] = $this->language->get('error_image_location');
		}

		return !$this->error;
	}
}
