<?php
/**
 * @package	    Jarda CMS
 * @author	    Yvonne Emmerig
 * @copyright	Copyright (c) 2005 - 2020, Dymago (https://www.dymago.com/)
 * @license	    https://opensource.org/licenses/GPL-3.0
 * @link	    https://www.jarda.nl
*/
// Locale
$_['code']                          = 'en';
$_['direction']                     = 'ltr';
$_['date_format_short']             = 'd/m/Y';
$_['date_format_long']              = 'l dS F Y';
$_['time_format']                   = 'h:i:s A';
$_['datetime_format']               = 'd/m/Y H:i:s';
$_['decimal_point']                 = '.';
$_['thousand_point']                = ',';

// Text
$_['text_yes']                      = 'Yes';
$_['text_no']                       = 'No';
$_['text_enabled']                  = 'Enabled';
$_['text_disabled']                 = '<span style="color:red;">Disabled</span>';
$_['text_none']                     = ' --- None --- ';
$_['text_select']                   = ' --- Please Select --- ';
$_['text_select_all']               = 'Select All';
$_['text_unselect_all']             = 'Unselect All';
$_['text_all_zones']                = 'All Zones';
$_['text_default']                  = ' <b>(Default)</b>';
$_['text_close']                    = 'Close';
$_['text_pagination']               = 'Showing %d to %d of %d (%d Pages)';
$_['text_loading']                  = 'Loading...';
$_['text_no_results']               = 'No results!';
$_['text_confirm']                  = 'Are you sure?';
$_['text_home']                     = 'Home';

// Button
$_['button_add']                    = 'Add New';
$_['button_delete']                 = 'Delete';
$_['button_save']                   = 'Save';
$_['button_cancel']                 = 'Cancel';
$_['button_continue']               = 'Continue';
$_['button_clear_filter']           = 'Clear filter';
$_['button_clear']                  = 'Clear';
$_['button_close']                  = 'Close';
$_['button_enable']                 = 'Enable';
$_['button_disable']                = 'Disable';
$_['button_filter']                 = 'Filter';
$_['button_send']                   = 'Send';
$_['button_edit']                   = 'Edit';
$_['button_copy']                   = 'Copy';
$_['button_back']                   = 'Back';
$_['button_remove']                 = 'Remove';
$_['button_refresh']                = 'Refresh';
$_['button_export']                 = 'Export';
$_['button_import']                 = 'Import';
$_['button_download']               = 'Download';
$_['button_rebuild']                = 'Rebuild';
$_['button_upload']                 = 'Upload';
$_['button_submit']                 = 'Submit';
$_['button_attribute_add']          = 'Add Attribute';
$_['button_banner_add']             = 'Add Banner';
$_['button_image_add']              = 'Add Image';
$_['button_geo_zone_add']           = 'Add Geo Zone';
$_['button_translation']            = 'Load Default Translation';
$_['button_translation_add']        = 'Add Translation';
$_['button_route_add']              = 'Add Route';
$_['button_rule_add']               = 'Add Rule';
$_['button_module_add']             = 'Add Module';
$_['button_link_add']               = 'Add Link';
$_['button_approve']                = 'Approve';
$_['button_deny']                   = 'Deny';
$_['button_reset']                  = 'Reset';
$_['button_generate']               = 'Generate';
$_['button_ip_add']                 = 'Add IP';
$_['button_parent']                 = 'Parent';
$_['button_folder']                 = 'New Folder';
$_['button_search']                 = 'Search';
$_['button_view']                   = 'View';
$_['button_install']                = 'Install';
$_['button_uninstall']              = 'Uninstall';
$_['button_link']                   = 'Link';
$_['button_apply']                  = 'Apply';
$_['button_category_add']           = 'Add Category';
$_['button_toggle']                 = 'Uitklappen/ inklappen';

// Tab
$_['tab_additional']                = 'Additional';
$_['tab_admin']                     = 'Admin';
$_['tab_attribute']                 = 'Attribute';
$_['tab_comment']                   = 'Comment';
$_['tab_data']                      = 'Data';
$_['tab_description']               = 'Description';
$_['tab_design']                    = 'Design';
$_['tab_documentation']             = 'Documentation';
$_['tab_general']                   = 'General';
$_['tab_ip']                        = 'IP Addresses';
$_['tab_links']                     = 'Links';
$_['tab_log']                       = 'Log';
$_['tab_image']                     = 'Image';
$_['tab_option']                    = 'Option';
$_['tab_server']                    = 'Server';
$_['tab_seo']                       = 'SEO';
$_['tab_site']                      = 'Website';
$_['tab_session']                   = 'Session';
$_['tab_local']                     = 'Local';
$_['tab_mail']                      = 'Mail';
$_['tab_module']                    = 'Module';
$_['tab_online']                    = 'People Online';
$_['tab_action']                    = 'Action';
$_['tab_google']                    = 'Google';

// Error
$_['error_exception']               = 'Error Code(%s): %s in %s on line %s';
$_['error_upload_1']                = 'Warning: The uploaded file exceeds the upload_max_filesize directive in php.ini!';
$_['error_upload_2']                = 'Warning: The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form!';
$_['error_upload_3']                = 'Warning: The uploaded file was only partially uploaded!';
$_['error_upload_4']                = 'Warning: No file was uploaded!';
$_['error_upload_6']                = 'Warning: Missing a temporary folder!';
$_['error_upload_7']                = 'Warning: Failed to write file to disk!';
$_['error_upload_8']                = 'Warning: File upload stopped by extension!';
$_['error_upload_999']              = 'Warning: No error code available!';
$_['error_curl']                    = 'CURL: Error Code(%s): %s';

// Summernote
//$_['summernote']                    = 'en-GB';

// Datepicker
$_['datepicker']                    = 'en-gb';