<?php
/**
 * @package	    Jarda CMS - Website Theme
 * @author	    Yvonne Emmerig
 * @copyright	Copyright (c) 2005 - 2020, Dymago (https://www.dymago.com/)
 * @license	    https://opensource.org/licenses/GPL-3.0
 * @link	    https://www.jarda.nl
*/
// Heading
$_['heading_title']                         = 'Jarda Theme';

// Text
$_['text_extension']                        = 'Extensions';
$_['text_success']                          = 'Success: You have modified the default theme!';
$_['text_edit']                             = 'Edit Theme';
$_['text_general']                          = 'General';
$_['text_theme']                            = 'Theme';
$_['text_status']                           = 'Status';
$_['text_information']                      = 'Information';
$_['text_social_media']                     = 'Social Media';
$_['text_team']                             = 'Team';
$_['text_manufacturer']                     = 'Manufacturers';
$_['text_brand']                     		= 'Brands';
$_['text_webshop']                          = 'Webshop';
$_['text_image_category']                   = 'Category Images';
$_['text_image_information']                = 'Article Images';
$_['text_image_team']                       = 'Team Image';
$_['text_image_manufacturer']               = 'Manufacturer Image';
$_['text_image_brand']               		= 'Brand Image';
$_['text_image_location']                   = 'Locatie Image';

// Entry
$_['entry_directory']                       = 'Theme Directory';
$_['entry_status']                          = 'Status';
$_['entry_information_limit']               = 'Default Items Per Page';
$_['entry_information_description_length']  = 'List Description Limit';
$_['entry_social_code']                     = 'Unique Code snippet';
$_['entry_social_share_toolbox']            = 'Inline Share Button code';
$_['entry_social_share']                    = 'Show share buttons';
$_['entry_social_follow']                   = 'Show follow buttons';
$_['entry_team_menu']                       = 'Team in menus';
$_['entry_team_footer']                     = 'Team in footer';
$_['entry_manufacturer_menu']               = 'Manufacturers in menus';
$_['entry_manufacturer_footer']             = 'Manufacturers in footer';
$_['entry_brand_menu']               		= 'Brands in menus';
$_['entry_brand_footer']             		= 'Brands in footer';
$_['entry_webshop_footer']                  = 'Webshop in footer';
$_['entry_image_category']                  = 'Category Image Size (W x H)';
$_['entry_image_subcategory']               = 'Sub Category Image Size (W x H)';
$_['entry_image_team']                      = 'Team Image Size (W x H)';
$_['entry_image_manufacturer']              = 'Manufacturer Image Size (W x H)';
$_['entry_image_brand']              		= 'Brand Image Size (W x H)';
$_['entry_image_thumb']                     = 'Article (W x H)';
$_['entry_image_popup']                     = 'Popup (W x H)';
$_['entry_image_information']               = 'List (W x H)';
$_['entry_image_additional']                = 'Additional article (W x H)';
$_['entry_image_related']                   = 'Related Article thumb (W x H)';
$_['entry_image_location']                  = 'Website Image Size (W x H)';
$_['entry_width']                           = 'Width';
$_['entry_height']                          = 'Height';

// Tab
$_['tab_general']                           = 'General';
$_['tab_images']                            = 'Images';

// Help
$_['help_directory']                        = 'You can set the theme directory to use the settings defined here.';
$_['help_information_limit']                = 'Determines how many items are shown per page in the Lists';
$_['help_information_description_length']   = 'Determine the maximum number of characters for the description in the Lists';
$_['help_social_code']                      = 'To show Social share buttons in information pages and follow buttons in footer, you need to have an Addthis account. Go to <a href="https://www.addthis.com/register" target="_blank">https://www.addthis.com</a> to register a free account, login and get your code. Only copy the code after #pubid= and paste it here.';
$_['help_social_share_toolbox']             = 'When you get your social code snippet you also get an Inline Share Button code. Copy the code like this:  addthis_inline_share_toolbox_xxxx and paste it here';
$_['help_social_share']                     = 'Show Social share buttons in information pages. You can add Exceptions in the Information Pages extension.';
$_['help_social_follow']                    = 'Show Social follow buttons in footer';
$_['help_team_menu']                        = 'Only Enable if you want to show the link in the main menu at the top, module menus and sitemap.';
$_['help_team_footer']                      = 'Only Enable if you want to show the link in the footer';
$_['help_manufacturer_menu']                = 'Only Enable if you want to show the link to the list in the main menu at the top, module menus and sitemap.';
$_['help_manufacturer_footer']              = 'Only Enable if you want to show the link to the list in the footer';
$_['help_brand_menu']                		= 'Only Enable if you want to show the link to the list in the main menu at the top, module menus and sitemap.';
$_['help_brand_footer']              		= 'Only Enable if you want to show the link to the list in the footer';
$_['help_webshop_footer']                   = 'Only Enable if you want to show the link to your webshop in the footer';

// Error
$_['error_permission']                      = 'Warning: You do not have permission to modify the default theme!';
$_['error_limit']                           = 'Information Limit required!';
$_['error_image_category']                  = 'Category List Size dimensions required!';
$_['error_image_subcategory']               = 'Sub Category List Size dimensions required!';
$_['error_image_team']                      = 'Team Image Size dimensions required!';
$_['error_image_manufacturer']              = 'Manufacturer Image Size dimensions required!';
$_['error_image_brand']              		= 'Brand Image Size dimensions required!';
$_['error_image_thumb']                     = 'Article Image Thumb Size dimensions required!';
$_['error_image_popup']                     = 'Article Image Popup Size dimensions required!';
$_['error_image_information']               = 'Article List Size dimensions required!';
$_['error_image_additional']                = 'Additional Information Image Size dimensions required!';
$_['error_image_related']                   = 'Related Information Image Size dimensions required!';
$_['error_image_location']                  = 'Website Image Size dimensions required!';