<?php
class ModelCatalogBrand extends Model {
	public function addBrand($data) {
		$this->db->query("INSERT INTO " . DB_PREFIX . "brand SET name = '" . $this->db->escape($data['name']) . "', sort_order = '" . (int)$data['sort_order'] . "'");

		$brand_id = $this->db->getLastId();

        foreach ($data['brand_description'] as $language_id => $value) {
            $this->db->query("INSERT INTO " . DB_PREFIX . "brand_description SET brand_id = '" . (int)$brand_id . "', language_id = '" . (int)$language_id . "', description = '" . $this->db->escape($value['description']) . "', meta_title = '" . $this->db->escape($value['meta_title']) . "', meta_description = '" . $this->db->escape($value['meta_description']) . "', meta_keyword = '" . $this->db->escape($value['meta_keyword']) . "'");
        }

        if (isset($data['image'])) {
			$this->db->query("UPDATE " . DB_PREFIX . "brand SET image = '" . $this->db->escape($data['image']) . "' WHERE brand_id = '" . (int)$brand_id . "'");
		}

		if (isset($data['brand_site'])) {
			foreach ($data['brand_site'] as $site_id) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "brand_to_site SET brand_id = '" . (int)$brand_id . "', site_id = '" . (int)$site_id . "'");
			}
		}

		// SEO URL
		if (isset($data['brand_seo_url'])) {
			foreach ($data['brand_seo_url'] as $site_id => $language) {
				foreach ($language as $language_id => $keyword) {
					if (!empty($keyword)) {
						$this->db->query("INSERT INTO " . DB_PREFIX . "seo_url SET site_id = '" . (int)$site_id . "', language_id = '" . (int)$language_id . "', query = 'brand_id=" . (int)$brand_id . "', keyword = '" . $this->db->escape($keyword) . "'");
					}
				}
			}
		}

		$this->cache->delete('brand');

		return $brand_id;
	}

	public function editBrand($brand_id, $data) {
		$this->db->query("UPDATE " . DB_PREFIX . "brand SET name = '" . $this->db->escape($data['name']) . "', sort_order = '" . (int)$data['sort_order'] . "' WHERE brand_id = '" . (int)$brand_id . "'");

        $this->db->query("DELETE FROM " . DB_PREFIX . "brand_description WHERE brand_id = '" . (int)$brand_id . "'");

        foreach ($data['brand_description'] as $language_id => $value) {
            $this->db->query("INSERT INTO " . DB_PREFIX . "brand_description SET brand_id = '" . (int)$brand_id . "', language_id = '" . (int)$language_id . "', description = '" . $this->db->escape($value['description']) . "', meta_title = '" . $this->db->escape($value['meta_title']) . "', meta_description = '" . $this->db->escape($value['meta_description']) . "', meta_keyword = '" . $this->db->escape($value['meta_keyword']) . "'");
        }

		if (isset($data['image'])) {
			$this->db->query("UPDATE " . DB_PREFIX . "brand SET image = '" . $this->db->escape($data['image']) . "' WHERE brand_id = '" . (int)$brand_id . "'");
		}

		$this->db->query("DELETE FROM " . DB_PREFIX . "brand_to_site WHERE brand_id = '" . (int)$brand_id . "'");

		if (isset($data['brand_site'])) {
			foreach ($data['brand_site'] as $site_id) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "brand_to_site SET brand_id = '" . (int)$brand_id . "', site_id = '" . (int)$site_id . "'");
			}
		}

		$this->db->query("DELETE FROM `" . DB_PREFIX . "seo_url` WHERE query = 'brand_id=" . (int)$brand_id . "'");

		if (isset($data['brand_seo_url'])) {
			foreach ($data['brand_seo_url'] as $site_id => $language) {
				foreach ($language as $language_id => $keyword) {
					if (!empty($keyword)) {
						$this->db->query("INSERT INTO `" . DB_PREFIX . "seo_url` SET site_id = '" . (int)$site_id . "', language_id = '" . (int)$language_id . "', query = 'brand_id=" . (int)$brand_id . "', keyword = '" . $this->db->escape($keyword) . "'");
					}
				}
			}
		}

		$this->cache->delete('brand');
	}

	public function deleteBrand($brand_id) {
		$this->db->query("DELETE FROM `" . DB_PREFIX . "brand` WHERE brand_id = '" . (int)$brand_id . "'");
        $this->db->query("DELETE FROM `" . DB_PREFIX . "brand_description` WHERE brand_id = '" . (int)$brand_id . "'");
		$this->db->query("DELETE FROM `" . DB_PREFIX . "brand_to_site` WHERE brand_id = '" . (int)$brand_id . "'");
		$this->db->query("DELETE FROM `" . DB_PREFIX . "seo_url` WHERE query = 'brand_id=" . (int)$brand_id . "'");

		$this->cache->delete('brand');
	}

	public function getBrand($brand_id) {
		$query = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "brand WHERE brand_id = '" . (int)$brand_id . "'");

		return $query->row;
	}

	public function getBrands($data = array()) {
		$sql = "SELECT * FROM " . DB_PREFIX . "brand";

		if (!empty($data['filter_name'])) {
			$sql .= " WHERE name LIKE '" . $this->db->escape($data['filter_name']) . "%'";
		}

		$sort_data = array(
			'name',
			'sort_order'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->rows;
	}

    public function getBrandDescriptions($brand_id) {
        $brand_description_data = array();

        $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "brand_description WHERE brand_id = '" . (int)$brand_id . "'");

        foreach ($query->rows as $result) {
            $brand_description_data[$result['language_id']] = array(
                'meta_title'       => $result['meta_title'],
                'meta_description' => $result['meta_description'],
                'meta_keyword'     => $result['meta_keyword'],
                'description'      => $result['description']
            );
        }

        return $brand_description_data;
    }

    public function getBrandSites($brand_id) {
		$brand_site_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "brand_to_site WHERE brand_id = '" . (int)$brand_id . "'");

		foreach ($query->rows as $result) {
			$brand_site_data[] = $result['site_id'];
		}

		return $brand_site_data;
	}

	public function getBrandSeoUrls($brand_id) {
		$brand_seo_url_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "seo_url WHERE query = 'brand_id=" . (int)$brand_id . "'");

		foreach ($query->rows as $result) {
			$brand_seo_url_data[$result['site_id']][$result['language_id']] = $result['keyword'];
		}

		return $brand_seo_url_data;
	}

	public function getTotalBrands() {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "brand");

		return $query->row['total'];
	}
}
