<?php
class ModelCatalogInformation extends Model {
	public function addInformation($data) {
		$this->db->query("INSERT INTO " . DB_PREFIX . "information SET sort_order = '" . (int)$data['sort_order'] . "', bottom = '" . (isset($data['bottom']) ? (int)$data['bottom'] : 0) . "', manufacturer_id = '" . (int)$data['manufacturer_id'] . "', brand_id = '" . (int)$data['brand_id'] . "', date_available = '" . $this->db->escape($data['date_available']) . "', date_end = '" . $this->db->escape($data['date_end']) . "', date_added = NOW(), date_modified = NOW(), status = '" . (int)$data['status'] . "'");

		$information_id = $this->db->getLastId();

        if (isset($data['information_document'])) {
            $this->installInformationDocuments();

            foreach ($data['information_document'] as $information_document) {
                $sql = "INSERT INTO " . DB_PREFIX . "information_document SET information_id = '" . (int)$information_id . "', document = '" . $this->db->escape($information_document['document']) . "', sort_order = '" . (int)$information_document['sort_order'] . "'";
                $this->db->query($sql);
                $information_document_id = $this->db->getLastId();

                foreach($information_document['document_name'] as $key => $document_name) {
                    $sql = "INSERT INTO " . DB_PREFIX . "information_document_name SET information_document_id = '" . $information_document_id . "', information_id = '" . (int)$information_id . "', language_id = '" . $key . "', document_name = '" . $this->db->escape($document_name['name']) . "'";
                    $this->db->query($sql);
                }
            }
        }

		foreach ($data['information_description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "information_description SET information_id = '" . (int)$information_id . "', language_id = '" . (int)$language_id . "', title = '" . $this->db->escape($value['title']) . "', header = '" . $this->db->escape($value['header']) . "', short_description = '" . $this->db->escape($value['short_description']) . "', description = '" . $this->db->escape($value['description']) . "', tag = '" . $this->db->escape($value['tag']) . "', meta_title = '" . $this->db->escape($value['meta_title']) . "', meta_description = '" . $this->db->escape($value['meta_description']) . "', meta_keyword = '" . $this->db->escape($value['meta_keyword']) . "'");
		}

		if (isset($data['information_site'])) {
			foreach ($data['information_site'] as $site_id) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "information_to_site SET information_id = '" . (int)$information_id . "', site_id = '" . (int)$site_id . "'");
			}
		}

		if (!empty($data['user_id'])) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "information_to_user SET information_id = '" . (int)$information_id . "', user_id = '" . (int)$data['user_id'] . "'");
		}
/*
		if (!empty($data['team_id'])) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "information_to_team SET information_id = '" . (int)$information_id . "', team_id = '" . (int)$data['team_id'] . "'");
		}
*/
		if (isset($data['information_attribute'])) {
			foreach ($data['information_attribute'] as $information_attribute) {
				if ($information_attribute['attribute_id']) {
					// Removes duplicates
					$this->db->query("DELETE FROM " . DB_PREFIX . "information_attribute WHERE information_id = '" . (int)$information_id . "' AND attribute_id = '" . (int)$information_attribute['attribute_id'] . "'");

					foreach ($information_attribute['information_attribute_description'] as $language_id => $information_attribute_description) {
						$this->db->query("DELETE FROM " . DB_PREFIX . "information_attribute WHERE information_id = '" . (int)$information_id . "' AND attribute_id = '" . (int)$information_attribute['attribute_id'] . "' AND language_id = '" . (int)$language_id . "'");

						$this->db->query("INSERT INTO " . DB_PREFIX . "information_attribute SET information_id = '" . (int)$information_id . "', attribute_id = '" . (int)$information_attribute['attribute_id'] . "', language_id = '" . (int)$language_id . "', text = '" .  $this->db->escape($information_attribute_description['text']) . "'");
					}
				}
			}
		}

		if (isset($data['image'])) {
			$this->db->query("UPDATE " . DB_PREFIX . "information SET image = '" . $this->db->escape($data['image']) . "' WHERE information_id = '" . (int)$information_id . "'");
		}

		if (isset($data['information_image'])) {
			foreach ($data['information_image'] as $information_image) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "information_image SET information_id = '" . (int)$information_id . "', image = '" . $this->db->escape($information_image['image']) . "', sort_order = '" . (int)$information_image['sort_order'] . "'");
			}
		}

		if (isset($data['information_category'])) {
			foreach ($data['information_category'] as $category_id) {
				if (!empty($data['main_category']) && $data['main_category'] == (int)$category_id) {
					$this->db->query("INSERT INTO " . DB_PREFIX . "information_to_category SET information_id = '" . (int)$information_id . "', category_id = '" . (int)$category_id . "', main_category = '1'");
				} else {
					$this->db->query("INSERT INTO " . DB_PREFIX . "information_to_category SET information_id = '" . (int)$information_id . "', category_id = '" . (int)$category_id . "'");
				}
			}
		}

		if (isset($data['information_related'])) {
			foreach ($data['information_related'] as $information_related) {
				$this->db->query("DELETE FROM " . DB_PREFIX . "information_related WHERE information_id = '" . (int)$information_id . "' AND related_id = '" . (int)$information_related['information_id'] . "'");
				$this->db->query("INSERT INTO " . DB_PREFIX . "information_related SET information_id = '" . (int)$information_id . "', related_id = '" . (int)$information_related['information_id'] . "', route = '" . (int)$information_related['route'] . "'");
				$this->db->query("DELETE FROM " . DB_PREFIX . "information_related WHERE information_id = '" . (int)$information_related['information_id'] . "' AND related_id = '" . (int)$information_id . "'");
				$this->db->query("INSERT INTO " . DB_PREFIX . "information_related SET information_id = '" . (int)$information_related['information_id'] . "', related_id = '" . (int)$information_id . "', route = '" . (int)$information_related['route'] * -1 . "'");
			}
		}

        // SEO URL
		if (isset($data['information_seo_url'])) {
			foreach ($data['information_seo_url'] as $site_id => $language) {
				foreach ($language as $language_id => $keyword) {
					if (!empty($keyword)) {
						$this->db->query("INSERT INTO " . DB_PREFIX . "seo_url SET site_id = '" . (int)$site_id . "', language_id = '" . (int)$language_id . "', query = 'information_id=" . (int)$information_id . "', keyword = '" . $this->db->escape($keyword) . "'");
					}
				}
			}
		}

		if (isset($data['information_layout'])) {
			foreach ($data['information_layout'] as $site_id => $layout_id) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "information_to_layout SET information_id = '" . (int)$information_id . "', site_id = '" . (int)$site_id . "', layout_id = '" . (int)$layout_id . "'");
			}
		}

		$this->cache->delete('information');

		return $information_id;
	}

	public function editInformation($information_id, $data) {
		$this->db->query("UPDATE " . DB_PREFIX . "information SET sort_order = '" . (int)$data['sort_order'] . "', bottom = '" . (isset($data['bottom']) ? (int)$data['bottom'] : 0) . "', manufacturer_id = '" . (int)$data['manufacturer_id'] . "', brand_id = '" . (int)$data['brand_id'] . "', date_available = '" . $this->db->escape($data['date_available']) . "', date_end = '" . $this->db->escape($data['date_end']) . "', date_added = '" . $this->db->escape($data['date_added']) . "',  date_modified = NOW(), status = '" . (int)$data['status'] . "' WHERE information_id = '" . (int)$information_id . "'");

        $this->db->query("DELETE FROM " . DB_PREFIX . "information_document WHERE information_id = '" . (int)$information_id . "'");
        $this->db->query("DELETE FROM " . DB_PREFIX . "information_document_name WHERE information_id = '" . (int)$information_id . "'");

        if (isset($data['information_document'])) {
            foreach ($data['information_document'] as $information_document) {
                $sql = "INSERT INTO " . DB_PREFIX . "information_document SET information_id = '" . (int)$information_id . "', document = '" . $this->db->escape($information_document['document']) . "', sort_order = '" . (int)$information_document['sort_order'] . "'";
                $this->db->query($sql);

                $information_document_id = $this->db->getLastId();

                foreach($information_document['document_name'] as $key => $document_name) {
                    $sql = "INSERT INTO " . DB_PREFIX . "information_document_name SET information_document_id = '" . $information_document_id . "', information_id = '" . (int)$information_id . "', language_id = '" . $key . "', document_name = '" . $this->db->escape($document_name['name']) . "'";
                $this->db->query($sql);
                }
            }
        }

		$this->db->query("DELETE FROM " . DB_PREFIX . "information_description WHERE information_id = '" . (int)$information_id . "'");

		foreach ($data['information_description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "information_description SET information_id = '" . (int)$information_id . "', language_id = '" . (int)$language_id . "', title = '" . $this->db->escape($value['title']) . "', header = '" . $this->db->escape($value['header']) . "', short_description = '" . $this->db->escape($value['short_description']) . "', description = '" . $this->db->escape($value['description']) . "', tag = '" . $this->db->escape($value['tag']) . "', meta_title = '" . $this->db->escape($value['meta_title']) . "', meta_description = '" . $this->db->escape($value['meta_description']) . "', meta_keyword = '" . $this->db->escape($value['meta_keyword']) . "'");
		}

		$this->db->query("DELETE FROM " . DB_PREFIX . "information_to_site WHERE information_id = '" . (int)$information_id . "'");

		if (isset($data['information_site'])) {
			foreach ($data['information_site'] as $site_id) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "information_to_site SET information_id = '" . (int)$information_id . "', site_id = '" . (int)$site_id . "'");
			}
		}

		$this->db->query("DELETE FROM " . DB_PREFIX . "information_to_user WHERE information_id = '" . (int)$information_id . "'");

		if (!empty($data['user_id'])) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "information_to_user SET information_id = '" . (int)$information_id . "', user_id = '" . (int)$data['user_id'] . "'");
		}
/*
		$this->db->query("DELETE FROM " . DB_PREFIX . "information_to_team WHERE information_id = '" . (int)$information_id . "'");

        if (!empty($data['team_id'])) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "information_to_team SET information_id = '" . (int)$information_id . "', team_id = '" . (int)$data['team_id'] . "'");
		}
*/
		$this->db->query("DELETE FROM " . DB_PREFIX . "information_attribute WHERE information_id = '" . (int)$information_id . "'");

		if (!empty($data['information_attribute'])) {
			foreach ($data['information_attribute'] as $information_attribute) {
				if ($information_attribute['attribute_id']) {
					// Removes duplicates
					$this->db->query("DELETE FROM " . DB_PREFIX . "information_attribute WHERE information_id = '" . (int)$information_id . "' AND attribute_id = '" . (int)$information_attribute['attribute_id'] . "'");

					foreach ($information_attribute['information_attribute_description'] as $language_id => $information_attribute_description) {
						$this->db->query("INSERT INTO " . DB_PREFIX . "information_attribute SET information_id = '" . (int)$information_id . "', attribute_id = '" . (int)$information_attribute['attribute_id'] . "', language_id = '" . (int)$language_id . "', text = '" .  $this->db->escape($information_attribute_description['text']) . "'");
					}
				}
			}
		}

		if (isset($data['image'])) {
			$this->db->query("UPDATE " . DB_PREFIX . "information SET image = '" . $this->db->escape($data['image']) . "' WHERE information_id = '" . (int)$information_id . "'");
		}

		$this->db->query("DELETE FROM " . DB_PREFIX . "information_image WHERE information_id = '" . (int)$information_id . "'");

		if (isset($data['information_image'])) {
			foreach ($data['information_image'] as $information_image) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "information_image SET information_id = '" . (int)$information_id . "', image = '" . $this->db->escape($information_image['image']) . "', sort_order = '" . (int)$information_image['sort_order'] . "'");
			}
		}

		$this->db->query("DELETE FROM " . DB_PREFIX . "information_to_category WHERE information_id = '" . (int)$information_id . "'");

		if (isset($data['information_category'])) {
			foreach ($data['information_category'] as $category_id) {
				if (!empty($data['main_category']) && $data['main_category'] == (int)$category_id) {
					$this->db->query("INSERT INTO " . DB_PREFIX . "information_to_category SET information_id = '" . (int)$information_id . "', category_id = '" . (int)$category_id . "', main_category = '1'");
				} else {
					$this->db->query("INSERT INTO " . DB_PREFIX . "information_to_category SET information_id = '" . (int)$information_id . "', category_id = '" . (int)$category_id . "'");
				}
			}
		}

		$this->db->query("DELETE FROM " . DB_PREFIX . "information_related WHERE information_id = '" . (int)$information_id . "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "information_related WHERE related_id = '" . (int)$information_id . "'");

		if (isset($data['information_related'])) {
			foreach ($data['information_related'] as $information_related) {
				$this->db->query("DELETE FROM " . DB_PREFIX . "information_related WHERE information_id = '" . (int)$information_id . "' AND related_id = '" . (int)$information_related['information_id'] . "'");
				$this->db->query("INSERT INTO " . DB_PREFIX . "information_related SET information_id = '" . (int)$information_id . "', related_id = '" . (int)$information_related['information_id'] . "', route = '" . (int)$information_related['route'] . "'");
				$this->db->query("DELETE FROM " . DB_PREFIX . "information_related WHERE information_id = '" . (int)$information_related['information_id'] . "' AND related_id = '" . (int)$information_id . "'");
				$this->db->query("INSERT INTO " . DB_PREFIX . "information_related SET information_id = '" . (int)$information_related['information_id'] . "', related_id = '" . (int)$information_id . "', route = '" . (int)$information_related['route'] * -1 . "'");
			}
		}

        $this->db->query("DELETE FROM " . DB_PREFIX . "seo_url WHERE query = 'information_id=" . (int)$information_id . "'");

		if (isset($data['information_seo_url'])) {
			foreach ($data['information_seo_url'] as $site_id => $language) {
				foreach ($language as $language_id => $keyword) {
					if ($keyword) {
						$this->db->query("INSERT INTO `" . DB_PREFIX . "seo_url` SET site_id = '" . (int)$site_id . "', language_id = '" . (int)$language_id . "', query = 'information_id=" . (int)$information_id . "', keyword = '" . $this->db->escape($keyword) . "'");
					}
				}
			}
		}

		$this->db->query("DELETE FROM `" . DB_PREFIX . "information_to_layout` WHERE information_id = '" . (int)$information_id . "'");

		if (isset($data['information_layout'])) {
			foreach ($data['information_layout'] as $site_id => $layout_id) {
				$this->db->query("INSERT INTO `" . DB_PREFIX . "information_to_layout` SET information_id = '" . (int)$information_id . "', site_id = '" . (int)$site_id . "', layout_id = '" . (int)$layout_id . "'");
			}
		}

		$this->cache->delete('information');
	}

	public function copyInformation($information_id) {
		$query = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "information WHERE information_id = '" . (int)$information_id . "'");

		if ($query->num_rows) {
			$data = $query->row;

			$data['viewed'] = '0';
			$data['keyword'] = '';
			$data['status'] = '0';

			$data['information_attribute'] = $this->getInformationAttributes($information_id);
			$data['information_description'] = $this->getInformationDescriptions($information_id);
			$data['information_image'] = $this->getInformationImages($information_id);
			$data['information_related'] = $this->getInformationRelated($information_id);
			$data['information_category'] = $this->getInformationCategories($information_id);
			$data['main_category'] = $this->getMainCategory($information_id);
			$data['information_layout'] = $this->getInformationLayouts($information_id);
			$data['information_site'] = $this->getInformationSites($information_id);
			$data['user_id'] = $this->getInformationUser($information_id);
			//$data['team_id'] = $this->getInformationTeam($information_id);

			$this->addInformation($data);
		}
	}

    public function deleteInformation($information_id) {
		$this->db->query("DELETE FROM `" . DB_PREFIX . "information` WHERE information_id = '" . (int)$information_id . "'");
		$this->db->query("DELETE FROM `" . DB_PREFIX . "information_description` WHERE information_id = '" . (int)$information_id . "'");
		$this->db->query("DELETE FROM `" . DB_PREFIX . "information_to_site` WHERE information_id = '" . (int)$information_id . "'");
		$this->db->query("DELETE FROM `" . DB_PREFIX . "information_to_layout` WHERE information_id = '" . (int)$information_id . "'");
		$this->db->query("DELETE FROM `" . DB_PREFIX . "seo_url` WHERE query = 'information_id=" . (int)$information_id . "'");
		$this->db->query("DELETE FROM `" . DB_PREFIX . "information_attribute` WHERE information_id = '" . (int)$information_id . "'");
		$this->db->query("DELETE FROM `" . DB_PREFIX . "information_image` WHERE information_id = '" . (int)$information_id . "'");
		$this->db->query("DELETE FROM `" . DB_PREFIX . "information_related` WHERE information_id = '" . (int)$information_id . "'");
		$this->db->query("DELETE FROM `" . DB_PREFIX . "information_related` WHERE related_id = '" . (int)$information_id . "'");
		$this->db->query("DELETE FROM `" . DB_PREFIX . "information_to_category` WHERE information_id = '" . (int)$information_id . "'");
		$this->db->query("DELETE FROM `" . DB_PREFIX . "information_to_user` WHERE information_id = '" . (int)$information_id . "'");
		//$this->db->query("DELETE FROM `" . DB_PREFIX . "information_to_team` WHERE information_id = '" . (int)$information_id . "'");
		$this->db->query("DELETE FROM `" . DB_PREFIX . "review` WHERE information_id = '" . (int)$information_id . "'");
        $this->db->query("DELETE FROM `" . DB_PREFIX . "information_document` WHERE information_id = '" . (int)$information_id . "'");
        $this->db->query("DELETE FROM `" . DB_PREFIX . "information_document_name` WHERE information_id = '" . (int)$information_id . "'");

		$this->cache->delete('information');
	}

	public function getInformation($information_id) {
		$query = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "information i LEFT JOIN " . DB_PREFIX . "information_description id ON (i.information_id = id.information_id) WHERE i.information_id = '" . (int)$information_id . "' AND id.language_id = '" . (int)$this->config->get('config_language_id') . "'");

		return $query->row;
	}

	public function getInformations($data = array()) {
		if ($data) {
			if (isset($data['filter_category_id']) && $data['filter_category_id'] === '0') {
				$sql = "SELECT i.*, id.*, m.name AS manufacturer, b.name AS brand, IF(i.information_id IS NULL, '', '') AS category FROM " . DB_PREFIX . "information i LEFT JOIN " . DB_PREFIX . "information_description id ON (i.information_id = id.information_id) LEFT JOIN " . DB_PREFIX . "manufacturer m ON (i.manufacturer_id = m.manufacturer_id) WHERE id.language_id = '" . (int)$this->config->get('config_language_id') . "' LEFT JOIN " . DB_PREFIX . "brand b ON (i.brand_id = b.brand_id) WHERE id.language_id = '" . (int)$this->config->get('config_language_id') . "' AND i.information_id NOT IN (SELECT i2c.information_id FROM " . DB_PREFIX . "information_to_category i2c)";
			} else {
				$sql = "SELECT i.*, id.*, i2c1.main_category, m.name AS manufacturer, b.name AS brand, IF(i2c1.main_category = '1', (SELECT GROUP_CONCAT(cd1.name ORDER BY level SEPARATOR '&nbsp;&nbsp;&gt;&nbsp;&nbsp;') FROM " . DB_PREFIX . "category_path cp LEFT JOIN " . DB_PREFIX . "category_description cd1 ON (cp.path_id = cd1.category_id) WHERE cp.category_id = i2c1.category_id AND cd1.language_id = '" . (int)$this->config->get('config_language_id') . "' GROUP BY cp.category_id), '') AS category FROM " . DB_PREFIX . "information i LEFT JOIN " . DB_PREFIX . "information_description id ON (i.information_id = id.information_id) LEFT JOIN " . DB_PREFIX . "manufacturer m ON (i.manufacturer_id = m.manufacturer_id) LEFT JOIN " . DB_PREFIX . "brand b ON (i.brand_id = b.brand_id) LEFT JOIN " . DB_PREFIX . "information_to_category i2c1 ON (i.information_id = i2c1.information_id) LEFT JOIN " . DB_PREFIX . "category_description cd ON (i2c1.category_id = cd.category_id)";

				if (isset($data['filter_category_id']) && $data['filter_category_id'] !== '') {
					$sql .= " LEFT JOIN " . DB_PREFIX . "information_to_category i2c2 ON (i.information_id = i2c2.information_id) ";
				}

				$sql .= " WHERE id.language_id = '" . (int)$this->config->get('config_language_id') . "' AND (cd.language_id = '" . (int)$this->config->get('config_language_id') . "' OR cd.language_id IS NULL) AND (i2c1.main_category = (SELECT MAX(i2c2.main_category) FROM " . DB_PREFIX . "information_to_category i2c2 WHERE i2c2.information_id = i.information_id) OR i2c1.main_category IS NULL)";

				if (isset($data['filter_category_id']) && $data['filter_category_id'] !== '') {
					$sql .= " AND i2c2.category_id = '" . (int)$data['filter_category_id'] . "'";
				}
			}

			if (isset($data['filter_manufacturer_id']) && $data['filter_manufacturer_id'] !== '') {
				$sql .= " AND i.manufacturer_id = '" . (int)$data['filter_manufacturer_id'] . "'";
			}

			if (isset($data['filter_brand_id']) && $data['filter_brand_id'] !== '') {
				$sql .= " AND i.brand_id = '" . (int)$data['filter_brand_id'] . "'";
			}

		if (!empty($data['filter_name'])) {
			$sql .= " AND id.title LIKE '" . $this->db->escape($data['filter_name']) . "%'";
		}

		if (!empty($data['filter_viewed'])) {
			$sql .= " AND i.viewed LIKE '" . $this->db->escape($data['filter_viewed']) . "%'";
		}

		if (isset($data['filter_status']) && $data['filter_status'] !== '') {
			$sql .= " AND i.status = '" . (int)$data['filter_status'] . "'";
		}

		$sql .= " GROUP BY i.information_id";

            $sort_data = array(
				'id.title',
				'manufacturer',
				'brand',
				'category',
				'i.viewed',
				'i.status',
				'i.sort_order'
			);

			if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
				$sql .= " ORDER BY " . $data['sort'];
			} else {
				$sql .= " ORDER BY id.title";
			}

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = $this->db->query($sql);

			return $query->rows;
		} else {
			$information_data = $this->cache->get('information.' . (int)$this->config->get('config_language_id'));

			if (!$information_data) {
				$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "information i LEFT JOIN " . DB_PREFIX . "information_description id ON (i.information_id = id.information_id) WHERE id.language_id = '" . (int)$this->config->get('config_language_id') . "' ORDER BY id.title");

				$information_data = $query->rows;

				$this->cache->set('information.' . (int)$this->config->get('config_language_id'), $information_data);
			}

			return $information_data;
		}
	}

	public function getInformationDescriptions($information_id) {
		$information_description_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "information_description WHERE information_id = '" . (int)$information_id . "'");

		foreach ($query->rows as $result) {
			$information_description_data[$result['language_id']] = array(
				'title'            => $result['title'],
				'header'            => $result['header'],
				'short_description' => $result['short_description'],
				'tag'               => $result['tag'],
				'description'      => $result['description'],
				'meta_title'       => $result['meta_title'],
				'meta_description' => $result['meta_description'],
				'meta_keyword'     => $result['meta_keyword']
			);
		}

		return $information_description_data;
	}

    public function installInformationDocuments() {
        $this->db->query("CREATE TABLE if not exists " . DB_PREFIX . "information_document (information_document_id int(11) AUTO_INCREMENT, information_id int(11), document varchar(255), sort_order int(11), PRIMARY KEY (information_document_id)) engine=MyISAM default charset=UTF8");

        $sql = "CREATE TABLE if not exists " . DB_PREFIX . "information_document_name (information_document_id int(11), language_id int(11), information_id int(11), document_name varchar(255), PRIMARY KEY (information_document_id,language_id)) engine=MyISAM default charset=UTF8";
        
        $this->db->query($sql);
    }
    
    public function getInformationDocuments($information_id) {
        $this->installInformationDocuments();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "information_document WHERE information_id = '" . (int)$information_id . "' ORDER BY sort_order ASC");
        
        if ($query->row) {
            foreach($query->rows as $key=>$value) {
                $sql = " SELECT * FROM " . DB_PREFIX . "information_document_name WHERE information_document_id='" . $value['information_document_id'] . "'";
                
                $query_name = $this->db->query($sql);
                
                $document_name = array();
                
                if ($query_name->row) {
                    foreach($query_name->rows as $docname) {
                        $document_name[$docname['language_id']] = $docname['document_name'];
                    }
                }

                $query->rows[$key]['document_name'] = $document_name;
            }
        }
        return $query->rows;
    }

	public function getInformationSites($information_id) {
		$information_site_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "information_to_site WHERE information_id = '" . (int)$information_id . "'");

		foreach ($query->rows as $result) {
			$information_site_data[] = $result['site_id'];
		}

		return $information_site_data;
	}

	public function getInformationSeoUrls($information_id) {
		$information_seo_url_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "seo_url WHERE query = 'information_id=" . (int)$information_id . "'");

		foreach ($query->rows as $result) {
			$information_seo_url_data[$result['site_id']][$result['language_id']] = $result['keyword'];
		}

		return $information_seo_url_data;
	}

	public function getInformationLayouts($information_id) {
		$information_layout_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "information_to_layout WHERE information_id = '" . (int)$information_id . "'");

		foreach ($query->rows as $result) {
			$information_layout_data[$result['site_id']] = $result['layout_id'];
		}

		return $information_layout_data;
	}

	public function getInformationUser($information_id) {
		$query = $this->db->query("SELECT user_id FROM " . DB_PREFIX . "information_to_user WHERE information_id = '" . (int)$information_id . "'");

		return $query->row['user_id'];
	}
/*
	public function getInformationTeam($information_id) {
		$query = $this->db->query("SELECT team_id FROM " . DB_PREFIX . "information_to_team WHERE information_id = '" . (int)$information_id . "'");

		//return $query->row['team_id'];
        return $query->rows;
	}
*/
	public function getInformationsByCategoryId($category_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "information i LEFT JOIN " . DB_PREFIX . "information_description id ON (i.information_id = id.information_id) LEFT JOIN " . DB_PREFIX . "information_to_category i2c ON (i.information_id = i2c.information_id) WHERE id.language_id = '" . (int)$this->config->get('config_language_id') . "' AND i2c.category_id = '" . (int)$category_id . "' ORDER BY id.title ASC");

		return $query->rows;
	}

	public function getInformationCategories($information_id) {
		$information_category_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "information_to_category WHERE information_id = '" . (int)$information_id . "'");

		foreach ($query->rows as $result) {
			$information_category_data[] = $result['category_id'];
		}

		return $information_category_data;
	}

	public function getMainCategory($information_id) {
		$query = $this->db->query("SELECT category_id FROM " . DB_PREFIX . "information_to_category WHERE information_id = '" . (int)$information_id . "' AND main_category = '1'");

		if ($query->row) {
			return $query->row['category_id'];
		} else {
			return '';
		}
	}

	public function getInformationAttributes($information_id) {
		$information_attribute_data = array();

		$information_attribute_query = $this->db->query("SELECT attribute_id FROM " . DB_PREFIX . "information_attribute WHERE information_id = '" . (int)$information_id . "' GROUP BY attribute_id");

		foreach ($information_attribute_query->rows as $information_attribute) {
			$information_attribute_description_data = array();

			$information_attribute_description_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "information_attribute WHERE information_id = '" . (int)$information_id . "' AND attribute_id = '" . (int)$information_attribute['attribute_id'] . "'");

			foreach ($information_attribute_description_query->rows as $information_attribute_description) {
				$information_attribute_description_data[$information_attribute_description['language_id']] = array('text' => $information_attribute_description['text']);
			}

			$information_attribute_data[] = array(
				'attribute_id'                  => $information_attribute['attribute_id'],
				'information_attribute_description' => $information_attribute_description_data
			);
		}

		return $information_attribute_data;
	}

	public function getInformationImages($information_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "information_image WHERE information_id = '" . (int)$information_id . "' ORDER BY sort_order ASC");

		return $query->rows;
	}
	
	public function getInformationRelated($information_id) {
		$information_related_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "information_related WHERE information_id = '" . (int)$information_id . "'");

		foreach ($query->rows as $result) {
			$information_related_data[] = array(
				'information_id' => $result['related_id'],
				'route'          => $result['route']
            );
		}

		return $information_related_data;
	}

	public function getTotalInformationsByManufacturerId($manufacturer_id) {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "information WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");

		return $query->row['total'];
	}

	public function getTotalInformationsByBrandId($brand_id) {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "information WHERE brand_id = '" . (int)$brand_id . "'");

		return $query->row['total'];
	}

	public function getTotalInformationsByAttributeId($attribute_id) {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "information_attribute WHERE attribute_id = '" . (int)$attribute_id . "'");

		return $query->row['total'];
	}

    public function getTotalInformations($data = array()) {
		if (isset($data['filter_category_id']) && $data['filter_category_id'] === '0') {
			$sql = "SELECT COUNT(DISTINCT i.information_id) AS total FROM " . DB_PREFIX . "information i LEFT JOIN " . DB_PREFIX . "information_description id ON (i.information_id = id.information_id)";

			$sql .= " WHERE id.language_id = '" . (int)$this->config->get('config_language_id') . "'";

			$sql .= " AND i.information_id NOT IN (SELECT i2c.information_id FROM " . DB_PREFIX . "information_to_category i2c)";
		} else {
			$sql = "SELECT COUNT(DISTINCT i.information_id) AS total FROM " . DB_PREFIX . "information i LEFT JOIN " . DB_PREFIX . "information_to_category i2c ON (i.information_id = i2c.information_id) LEFT JOIN " . DB_PREFIX . "information_description id ON (i.information_id = id.information_id)";

			$sql .= " WHERE id.language_id = '" . (int)$this->config->get('config_language_id') . "'";

			if (isset($data['filter_category_id']) && $data['filter_category_id'] !== '') {
				$sql .= " AND i2c.category_id = '" . (int)$data['filter_category_id'] . "'";
			}
		}

		if (isset($data['filter_manufacturer_id']) && $data['filter_manufacturer_id'] !== '') {
			$sql .= " AND i.manufacturer_id = '" . (int)$data['filter_manufacturer_id'] . "'";
		}

		if (isset($data['filter_brand_id']) && $data['filter_brand_id'] !== '') {
			$sql .= " AND i.brand_id = '" . (int)$data['filter_brand_id'] . "'";
		}

		if (!empty($data['filter_name'])) {
			$sql .= " AND id.title LIKE '" . $this->db->escape($data['filter_name']) . "%'";
		}

		if (isset($data['filter_viewed']) && $data['filter_viewed'] !== '') {
			$sql .= " AND i.viewed = '" . (int)$data['filter_viewed'] . "'";
		}

		if (isset($data['filter_status']) && $data['filter_status'] !== '') {
			$sql .= " AND i.status = '" . (int)$data['filter_status'] . "'";
		}

		$query = $this->db->query($sql);

		return $query->row['total'];
	}

	public function getTotalInformationsByLayoutId($layout_id) {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "information_to_layout WHERE layout_id = '" . (int)$layout_id . "'");

		return $query->row['total'];
	}
}