<?php
class ModelCatalogTeam extends Model {
	public function addTeam($data) {
		$this->db->query("INSERT INTO " . DB_PREFIX . "team SET team_group_id = '" . (int)$data['team_group_id'] . "', fullname = '" . $this->db->escape($data['fullname']) . "', phone = '" . $this->db->escape($data['phone']) . "', email = '" . $this->db->escape($data['email']) . "', status = '" . (int)$data['status'] . "', sort_order = '" . (int)$data['sort_order'] . "'");

		$team_id = $this->db->getLastId();

		foreach ($data['team_description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "team_description SET team_id = '" . (int)$team_id . "', language_id = '" . (int)$language_id . "', description = '" . $this->db->escape($value['description']) . "'");
		}

		if (isset($data['image'])) {
			$this->db->query("UPDATE " . DB_PREFIX . "team SET image = '" . $this->db->escape($data['image']) . "' WHERE team_id = '" . (int)$team_id . "'");
		}

		if (isset($data['team_site'])) {
			foreach ($data['team_site'] as $site_id) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "team_to_site SET team_id = '" . (int)$team_id . "', site_id = '" . (int)$site_id . "'");
			}
		}

		$this->cache->delete('team');

		return $team_id;
	}

	public function editTeam($team_id, $data) {
		$this->db->query("UPDATE " . DB_PREFIX . "team SET team_group_id = '" . (int)$data['team_group_id'] . "', fullname = '" . $this->db->escape($data['fullname']) . "', phone = '" . $this->db->escape($data['phone']) . "', email = '" . $this->db->escape($data['email']) . "', status = '" . (int)$data['status'] . "', sort_order = '" . (int)$data['sort_order'] . "' WHERE team_id = '" . (int)$team_id . "'");

		$this->db->query("DELETE FROM " . DB_PREFIX . "team_description WHERE team_id = '" . (int)$team_id . "'");

		foreach ($data['team_description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "team_description SET team_id = '" . (int)$team_id . "', language_id = '" . (int)$language_id . "', description = '" . $this->db->escape($value['description']) . "'");
		}

		if (isset($data['image'])) {
			$this->db->query("UPDATE " . DB_PREFIX . "team SET image = '" . $this->db->escape($data['image']) . "' WHERE team_id = '" . (int)$team_id . "'");
		}

		$this->db->query("DELETE FROM " . DB_PREFIX . "team_to_site WHERE team_id = '" . (int)$team_id . "'");

		if (isset($data['team_site'])) {
			foreach ($data['team_site'] as $site_id) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "team_to_site SET team_id = '" . (int)$team_id . "', site_id = '" . (int)$site_id . "'");
			}
		}

		$this->cache->delete('team');
	}

	public function deleteTeam($team_id) {
		$this->db->query("DELETE FROM `" . DB_PREFIX . "team` WHERE team_id = '" . (int)$team_id . "'");
		$this->db->query("DELETE FROM `" . DB_PREFIX . "team_description` WHERE team_id = '" . (int)$team_id . "'");
		$this->db->query("DELETE FROM `" . DB_PREFIX . "team_to_site` WHERE team_id = '" . (int)$team_id . "'");

		$this->cache->delete('team');
	}

	public function getTeam($team_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "team t LEFT JOIN " . DB_PREFIX . "team_description td ON (t.team_id = td.team_id) WHERE t.team_id = '" . (int)$team_id . "' AND td.language_id = '" . (int)$this->config->get('config_language_id') . "'");

		return $query->row;
	}

	public function getTeams($data = array()) {
		$sql = "SELECT *, (SELECT tgd.name FROM " . DB_PREFIX . "team_group_description tgd WHERE tgd.team_group_id = t.team_group_id AND tgd.language_id = '" . (int)$this->config->get('config_language_id') . "') AS team_group FROM " . DB_PREFIX . "team t LEFT JOIN " . DB_PREFIX . "team_description td ON (t.team_id = td.team_id) WHERE td.language_id = '" . (int)$this->config->get('config_language_id') . "'";

		if (!empty($data['filter_description'])) {
			$sql .= " AND td.description LIKE '" . $this->db->escape($data['filter_description']) . "%'";
		}

		if (!empty($data['filter_team_group_id'])) {
			$sql .= " AND t.team_group_id = '" . $this->db->escape($data['filter_team_group_id']) . "'";
		}

		$sort_data = array(
			'team_group'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY team_group";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->rows;
	}

	public function getTeamsByGroup($team_group_id) {
		$query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "team` WHERE team_group_id = '" . (int)$team_group_id . "' ORDER BY fullname");

		return $query->rows;
	}

	public function getTeamDescriptions($team_id) {
		$team_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "team_description WHERE team_id = '" . (int)$team_id . "'");

		foreach ($query->rows as $result) {
			$team_data[$result['language_id']] = array(
                'description' => $result['description']
            );
		}

		return $team_data;
	}

	public function getTeamSites($team_id) {
		$team_site_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "team_to_site WHERE team_id = '" . (int)$team_id . "'");

		foreach ($query->rows as $result) {
			$team_site_data[] = $result['site_id'];
		}

		return $team_site_data;
	}

	public function getTotalTeams() {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "team");

		return $query->row['total'];
	}

	public function getTotalTeamsByTeamId($team_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "team WHERE team_id = '" . (int)$team_id . "'");

		return $query->row['total'];
	}

    public function getTotalTeamsByTeamGroupId($team_group_id) {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "team WHERE team_group_id = '" . (int)$team_group_id . "'");

		return $query->row['total'];
	}
}
