<?php
class ModelCatalogTeamGroup extends Model {
	public function addTeamGroup($data) {
		$this->db->query("INSERT INTO " . DB_PREFIX . "team_group SET sort_order = '" . (int)$data['sort_order'] . "'");

		$team_group_id = $this->db->getLastId();

		foreach ($data['team_group_description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "team_group_description SET team_group_id = '" . (int)$team_group_id . "', language_id = '" . (int)$language_id . "', name = '" . $this->db->escape($value['name']) . "'");
		}

		return $team_group_id;
	}

	public function editTeamGroup($team_group_id, $data) {
		$this->db->query("UPDATE " . DB_PREFIX . "team_group SET sort_order = '" . (int)$data['sort_order'] . "' WHERE team_group_id = '" . (int)$team_group_id . "'");

		$this->db->query("DELETE FROM " . DB_PREFIX . "team_group_description WHERE team_group_id = '" . (int)$team_group_id . "'");

		foreach ($data['team_group_description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "team_group_description SET team_group_id = '" . (int)$team_group_id . "', language_id = '" . (int)$language_id . "', name = '" . $this->db->escape($value['name']) . "'");
		}
	}

	public function deleteTeamGroup($team_group_id) {
		$this->db->query("DELETE FROM " . DB_PREFIX . "team_group WHERE team_group_id = '" . (int)$team_group_id . "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "team_group_description WHERE team_group_id = '" . (int)$team_group_id . "'");
	}

	public function getTeamGroup($team_group_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "team_group WHERE team_group_id = '" . (int)$team_group_id . "'");

		return $query->row;
	}

	public function getTeamGroups($data = array()) {
		$sql = "SELECT * FROM " . DB_PREFIX . "team_group tg LEFT JOIN " . DB_PREFIX . "team_group_description tgd ON (tg.team_group_id = tgd.team_group_id) WHERE tgd.language_id = '" . (int)$this->config->get('config_language_id') . "'";

		$sort_data = array(
			'tgd.name',
			'tg.sort_order'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY tgd.name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->rows;
	}

	public function getTeamGroupDescriptions($team_group_id) {
		$team_group_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "team_group_description WHERE team_group_id = '" . (int)$team_group_id . "'");

		foreach ($query->rows as $result) {
			$team_group_data[$result['language_id']] = array('name' => $result['name']);
		}

		return $team_group_data;
	}

	public function getTotalTeamGroups() {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "team_group");

		return $query->row['total'];
	}
}