<?php
class ModelReportOnline extends Model {
	public function getOnline($data = array()) {
		$sql = "SELECT ip, url, referer, date_added FROM " . DB_PREFIX . "visitor_online";

		$implode = array();

		if (!empty($data['filter_ip'])) {
			$implode[] = "ip LIKE '" . $this->db->escape($data['filter_ip']) . "'";
		}

		if ($implode) {
			$sql .= " WHERE " . implode(" AND ", $implode);
		}

		$sql .= " ORDER BY date_added DESC";

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->rows;
	}

	public function getTotalOnline($data = array()) {
		$sql = "SELECT COUNT(*) AS total FROM " . DB_PREFIX . "visitor_online";

		$implode = array();

		if (!empty($data['filter_ip'])) {
			$implode[] = "ip LIKE '" . $this->db->escape($data['filter_ip']) . "'";
		}

		if ($implode) {
			$sql .= " WHERE " . implode(" AND ", $implode);
		}

		$query = $this->db->query($sql);

		return $query->row['total'];
	}

	public function reset() {
		$this->db->query("TRUNCATE TABLE " . DB_PREFIX . "visitor_online");
	}
}