<?php
class ControllerCommonFooter extends Controller {
	public function index() {
		$this->load->language('common/footer');

		$this->load->model('catalog/information');

		$data['informations'] = array();

		foreach ($this->model_catalog_information->getInformations() as $result) {
			if ($result['bottom']) {
				$data['informations'][] = array(
					'title' => $result['title'],
					'href'  => $this->url->link('information/information', 'information_id=' . $result['information_id'])
				);
			}
		}

		$data['contact'] = $this->url->link('information/contact');
		$data['sitemap'] = $this->url->link('information/sitemap');
        
        // Social follow
        $data['social_follow_status'] = $this->config->get('theme_default_social_follow_status');
        $data['social_follow'] = 'addthis_inline_follow_toolbox';
        
        // Team
        $this->load->model('catalog/team');

        if ($this->config->get('theme_default_team_footer') && $this->config->get('theme_default_team_footer') == 1) {
            $data['team'] = $this->url->link('information/team');
        }
        
        // Manufacturer
        $this->load->model('catalog/manufacturer');

        if ($this->config->get('theme_default_manufacturer_footer') && $this->config->get('theme_default_manufacturer_footer') == 1) {
            $data['manufacturer'] = $this->url->link('information/manufacturer');
        }
        
        // Brand
        $this->load->model('catalog/brand');

        if ($this->config->get('theme_default_brand_footer') && $this->config->get('theme_default_brand_footer') == 1) {
            $data['brand'] = $this->url->link('information/brand');
        }
        
        // Webshop link
        if ($this->config->get('theme_default_webshop_footer') && $this->config->get('theme_default_webshop_footer') == 1) {
            $data['webshop_link'] = $this->config->get('config_webshop_link');
        }
        

        if (is_file(DIR_IMAGE . $this->config->get('config_icon'))) {
			$data['icon'] = 'image/' . $this->config->get('config_icon');
		} else {
			$data['icon'] = '';
		}

        $data['search'] = $this->url->link('information/search');
        $data['powered'] = sprintf($this->language->get('text_powered'), $this->config->get('config_name'), date('Y', time()));
        $data['development'] = sprintf($this->language->get('text_development') . ' ' . 'Dymago &copy;' . ' ');
		$data['website'] = 'https://www.dymago.com';
		$data['logo'] = 'image/logo.png';
        $data['copyright'] = sprintf($this->language->get('text_developer')) . '<br><i class="fas fa-phone-square-alt"></i>+31 (0)75 614 48 03<br><i class="fas fa-external-link-square-alt"></i>'. $this->language->get('text_visit');
       
		// Whos Online
		if ($this->config->get('config_visitor_online')) {
			$this->load->model('tool/online');

			if (isset($this->request->server['REMOTE_ADDR'])) {
				$ip = $this->request->server['REMOTE_ADDR'];
			} else {
				$ip = '';
			}

			if (isset($this->request->server['HTTP_HOST']) && isset($this->request->server['REQUEST_URI'])) {
				$url = ($this->request->server['HTTPS'] ? 'https://' : 'http://') . $this->request->server['HTTP_HOST'] . $this->request->server['REQUEST_URI'];
			} else {
				$url = '';
			}

			if (isset($this->request->server['HTTP_REFERER'])) {
				$referer = $this->request->server['HTTP_REFERER'];
			} else {
				$referer = '';
			}

			//$this->model_tool_online->addOnline($ip, $this->visitor->getId(), $url, $referer);
			$this->model_tool_online->addOnline($ip, $url, $referer);
		}

		$data['scripts'] = $this->document->getScripts('footer');

		return $this->load->view('common/footer', $data);
	}
}
