<?php
class ControllerCommonMenu extends Controller {
	public function index() {
		$this->load->language('common/menu');

		// Menu
		$this->load->model('catalog/category');

		$this->load->model('catalog/information');

        $data['categories'] = array();

		$categories = $this->model_catalog_category->getCategories(0);

		foreach ($categories as $category) {
			if ($category['top']) {
				// Level 2
				$children_data = array();

				$children = $this->model_catalog_category->getCategories($category['category_id']);

				foreach ($children as $child) {
					$filter_data = array(
						'filter_category_id'  => $child['category_id'],
						'filter_sub_category' => true
					);

					$children_data[] = array(
                        'name'  => $child['name'] . ($category['information'] ? ($category['information'] && $this->config->get('config_page_count') ? ' (' . $this->model_catalog_information->getTotalInformations($filter_data) . ')' : '') : ''),
						'href'  => $this->url->link('information/category', 'path=' . $category['category_id'] . '_' . $child['category_id'])
					);
				}

				// Level 1
				$data['categories'][] = array(
					'name'     => $category['name'],
					'children' => $children_data,
					'column'   => $category['column'] ? $category['column'] : 1,
					'href'     => $this->url->link('information/category', 'path=' . $category['category_id'])
				);
			}
		}

		$data['contact'] = $this->url->link('information/contact');

        // Team
		$this->load->model('catalog/team');

        if ($this->config->get('theme_default_team_menu') && $this->config->get('theme_default_team_menu') == 1) {
            $data['team'] = $this->url->link('information/team');
        }

        // Manufacturer
		$this->load->model('catalog/manufacturer');

        if ($this->config->get('theme_default_manufacturer_menu') && $this->config->get('theme_default_manufacturer_menu') == 1) {
            $data['manufacturer'] = $this->url->link('information/manufacturer');
        }

        // Brand
		$this->load->model('catalog/brand');

        if ($this->config->get('theme_default_brand_menu') && $this->config->get('theme_default_brand_menu') == 1) {
            $data['brand'] = $this->url->link('information/brand');
        }

        // Webshop link
        if ($this->config->get('config_webshop_link')) {
            $data['webshop_link'] = $this->config->get('config_webshop_link');
        }

		return $this->load->view('common/menu', $data);
	}
}
