<?php
class ControllerExtensionModuleFeaturedCategory extends Controller {
	public function index($setting) {
		$this->load->language('extension/module/featured_category');

		$this->load->model('catalog/category');

		$this->load->model('tool/image');

		$data['categories'] = array();

		if (!$setting['limit']) {
			$setting['limit'] = 4;
		}

		if (!empty($setting['categories'])) {

			$lang = $this->config->get('config_language_id');
			$title = isset($setting['titles']['title'.$lang]) && $setting['titles']['title'.$lang] ? $setting['titles']['title'.$lang] : '';

			if (isset($title) && $title) {
				$data['heading_title'] = $title;
			} else {
                $data['heading_title'] = '';
            }

			if (isset($meta_description) && $meta_description) {
				$data['meta_description'] = $meta_description;
			}

			if (isset($short_description) && $short_description) {
				$data['short_description'] = $short_description;
			}

        	$categories_data = array();

			foreach ($setting['categories'] as $category_id) {
				$category_info = $this->model_catalog_category->getCategory($category_id);

				if ($category_info) {
              		$categories_data[] = $category_info;
				}
			}

			$categories = array_slice($categories_data, 0, (int)$setting['limit']);

			foreach ($categories as $category) {
				if ($category['image']) {
					$image = $this->model_tool_image->resize($category['image'], $setting['width'], $setting['height']);
				} else {
					//$image = $this->model_tool_image->resize('placeholder.png', $setting['width'], $setting['height']);
                    //$image = $this->model_tool_image->resize($this->config->get('config_logo'), $setting['width'], $setting['height']);
                    $image = '';
				}

                $meta_description = html_entity_decode($category['meta_description'], ENT_QUOTES, 'UTF-8');
                $short_description = html_entity_decode($category['short_description'], ENT_QUOTES, 'UTF-8');

                $data['categories'][] = array(
					'category_id' 		=> $category['category_id'],
					'thumb'       		=> $image,
					'name'        		=> $category['name'],
					'meta_description' 	=> $meta_description,
					'short_description' => $short_description,
					'href'        		=> $this->url->link('information/category' . '&path=' . $category['category_id'])
				);
			}
		}

		$data['language'] = $this->config->get('config_language');

		if ($data['categories']) {
			return $this->load->view('extension/module/featured_category', $data);
		}
	}
}