<?php
class ControllerExtensionModuleInformation extends Controller {
	public function index() {
		$this->load->language('extension/module/information');

        $data['heading_title'] = $this->language->get('heading_title');

		$this->load->model('catalog/information');

		$data['informations'] = array();

		foreach ($this->model_catalog_information->getInformations() as $result) {
			$data['informations'][] = array(
				'title' => $result['title'],
				'href'  => $this->url->link('information/information', 'information_id=' . $result['information_id'])
			);
		}

		$data['contact'] = $this->url->link('information/contact');
		$data['sitemap'] = $this->url->link('information/sitemap');
        
        // Team
        $this->load->model('catalog/team');

        if ($this->config->get('theme_default_team_category_show') && $this->config->get('theme_default_team_category_show') == 1) {
            $data['team'] = $this->url->link('information/team');
        }

        // Manufacturer
        $this->load->model('catalog/manufacturer');

        if ($this->config->get('theme_default_manufacturer_category_show') && $this->config->get('theme_default_manufacturer_category_show') == 1) {
            $data['manufacturer'] = $this->url->link('information/manufacturer');
        }

        // Brand
        $this->load->model('catalog/brand');

        if ($this->config->get('theme_default_brand_category_show') && $this->config->get('theme_default_brand_category_show') == 1) {
            $data['brand'] = $this->url->link('information/brand');
        }

		return $this->load->view('extension/module/information', $data);
	}
}