<?php
class ControllerExtensionModuleInformationMenu extends Controller {
	public function index($setting) {
		$this->load->language('extension/module/information_menu');
        
        $data['heading_title'] = $this->language->get('heading_title');

		$this->load->model('catalog/information');

		$this->load->model('tool/image');

		$data['informations'] = array();

		if (!empty($setting['information'])) {
			$informations = array_slice($setting['information'], 0);

			foreach ($informations as $information_id) {
				$information_info = $this->model_catalog_information->getInformation($information_id);

				if ($information_info) {
					$data['informations'][] = array(
						'information_id' => $information_info['information_id'],
						'title'          => $information_info['title'],
						'href'           => $this->url->link('information/information', '&information_id=' . $information_info['information_id'])
					);
				}
			}
		}

		if ($data['informations']) {
			if ($setting['title'][$this->config->get('config_language_id')]) {
				$data['heading_title'] = html_entity_decode($setting['title'][$this->config->get('config_language_id')]);
			}

            $data['contact'] = $this->url->link('information/contact');

			return $this->load->view('extension/module/information_menu', $data);
		}
	}
}