<?php
class ControllerInformationInformation extends Controller {
	public function index() {
		$this->load->language('information/information');

		$this->load->model('catalog/information');

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$this->load->model('catalog/category');

		if (isset($this->request->get['path'])) {
			$path = '';

			$parts = explode('_', (string)$this->request->get['path']);

			$category_id = (int)array_pop($parts);

			foreach ($parts as $path_id) {
				if (!$path) {
					$path = $path_id;
				} else {
					$path .= '_' . $path_id;
				}

				$category_info = $this->model_catalog_category->getCategory($path_id);

				if ($category_info) {
					$data['breadcrumbs'][] = array(
						'text' => $category_info['name'],
						'href' => $this->url->link('information/category', 'path=' . $path)
					);
				}
			}

			// Set the last category breadcrumb
			$category_info = $this->model_catalog_category->getCategory($category_id);

			if ($category_info) {
				$url = '';

				if (isset($this->request->get['sort'])) {
					$url .= '&sort=' . $this->request->get['sort'];
				}

				if (isset($this->request->get['order'])) {
					$url .= '&order=' . $this->request->get['order'];
				}

				if (isset($this->request->get['page'])) {
					$url .= '&page=' . $this->request->get['page'];
				}

				if (isset($this->request->get['limit'])) {
					$url .= '&limit=' . $this->request->get['limit'];
				}

				$data['breadcrumbs'][] = array(
					'text' => $category_info['name'],
					'href' => $this->url->link('information/category', 'path=' . $this->request->get['path'] . $url)
				);
			}
		}

		$this->load->model('catalog/manufacturer');

		if (isset($this->request->get['manufacturer_id'])) {
			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_manufacturer'),
				'href' => $this->url->link('information/manufacturer')
			);

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			if (isset($this->request->get['limit'])) {
				$url .= '&limit=' . $this->request->get['limit'];
			}

			$manufacturer_info = $this->model_catalog_manufacturer->getManufacturer($this->request->get['manufacturer_id']);

			if ($manufacturer_info) {
				$data['breadcrumbs'][] = array(
					'text' => $manufacturer_info['name'],
					'href' => $this->url->link('information/manufacturer/info', 'manufacturer_id=' . $this->request->get['manufacturer_id'] . $url)
				);
			}
		}

		$this->load->model('catalog/brand');

		if (isset($this->request->get['brand_id'])) {
			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_brand'),
				'href' => $this->url->link('information/brand')
			);

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			if (isset($this->request->get['limit'])) {
				$url .= '&limit=' . $this->request->get['limit'];
			}

			$brand_info = $this->model_catalog_brand->getBrand($this->request->get['brand_id']);

			if ($brand_info) {
				$data['breadcrumbs'][] = array(
					'text' => $brand_info['name'],
					'href' => $this->url->link('information/brand/info', 'brand_id=' . $this->request->get['brand_id'] . $url)
				);
			}
		}

		if (isset($this->request->get['search']) || isset($this->request->get['tag'])) {
			$url = '';

			if (isset($this->request->get['search'])) {
				$url .= '&search=' . $this->request->get['search'];
			}

			if (isset($this->request->get['tag'])) {
				$url .= '&tag=' . $this->request->get['tag'];
			}

			if (isset($this->request->get['description'])) {
				$url .= '&description=' . $this->request->get['description'];
			}

			if (isset($this->request->get['category_id'])) {
				$url .= '&category_id=' . $this->request->get['category_id'];
			}

			if (isset($this->request->get['sub_category'])) {
				$url .= '&sub_category=' . $this->request->get['sub_category'];
			}

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			if (isset($this->request->get['limit'])) {
				$url .= '&limit=' . $this->request->get['limit'];
			}

			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_search'),
				'href' => $this->url->link('information/search', $url)
			);
		}

        if (isset($this->request->get['information_id'])) {
			$information_id = (int)$this->request->get['information_id'];
		} else {
			$information_id = 0;
		}

		$information_info = $this->model_catalog_information->getInformation($information_id);

		if ($information_info) {
			$main_category = $this->model_catalog_information->getMainCategory($information_id);

			if ($main_category) {
				$category_path = $this->model_catalog_category->getCategoryPath($main_category);
			} else {
				$category_path = '';
			}

			if (!isset($this->request->get['path']) && !isset($this->request->get['manufacturer_id']) && !isset($this->request->get['brand_id']) && !isset($this->request->get['search']) && !isset($this->request->get['tag']) && $main_category) {
				$this->request->get['path'] = $category_path;

				$path = '';

				$parts = explode('_', (string)$this->request->get['path']);
				(int)array_pop($parts);
      
				foreach ($parts as $path_id) {
					if (!$path) {
						$path = (int)$path_id;
					} else {
						$path .= '_' . (int)$path_id;
					}

					$category_info = $this->model_catalog_category->getCategory($path_id);

					if ($category_info) {
						$data['breadcrumbs'][] = array(
							'text' => $category_info['name'],
							'href' => $this->url->link('information/category', 'path=' . $path)
						);
					}
				}

				// Set the last category breadcrumb
				$category_info = $this->model_catalog_category->getCategory($main_category);

				if ($category_info) {
					$url = '';

					if (isset($this->request->get['sort'])) {
						$url .= '&sort=' . $this->request->get['sort'];
					}

					if (isset($this->request->get['order'])) {
						$url .= '&order=' . $this->request->get['order'];
					}

					if (isset($this->request->get['page'])) {
						$url .= '&page=' . $this->request->get['page'];
					}

					if (isset($this->request->get['limit'])) {
						$url .= '&limit=' . $this->request->get['limit'];
					}

					$data['breadcrumbs'][] = array(
						'text' => $category_info['name'],
						'href' => $this->url->link('information/category', 'path=' . $this->request->get['path'] . $url)
					);
				}
			}

			$url = '';

			if (isset($this->request->get['path'])) {
				$url .= '&path=' . $this->request->get['path'];
			}

			if (isset($this->request->get['filter'])) {
				$url .= '&filter=' . $this->request->get['filter'];
			}

			if (isset($this->request->get['manufacturer_id'])) {
				$url .= '&manufacturer_id=' . $this->request->get['manufacturer_id'];
			}

			if (isset($this->request->get['brand_id'])) {
				$url .= '&brand_id=' . $this->request->get['brand_id'];
			}

			if (isset($this->request->get['search'])) {
				$url .= '&search=' . $this->request->get['search'];
			}

			if (isset($this->request->get['tag'])) {
				$url .= '&tag=' . $this->request->get['tag'];
			}

			if (isset($this->request->get['description'])) {
				$url .= '&description=' . $this->request->get['description'];
			}

			if (isset($this->request->get['category_id'])) {
				$url .= '&category_id=' . $this->request->get['category_id'];
			}

			if (isset($this->request->get['sub_category'])) {
				$url .= '&sub_category=' . $this->request->get['sub_category'];
			}

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			if (isset($this->request->get['limit'])) {
				$url .= '&limit=' . $this->request->get['limit'];
			}

			if ($category_path) {
				$this->document->addLink($this->url->link('information/information', 'path=' . $category_path . '&information_id=' . $information_id), 'canonical');
			} else {
				$this->document->addLink($this->url->link('information/information', 'information_id=' . $information_id), 'canonical');
			}
			$this->document->addScript('catalog/view/javascript/jquery/magnific/jquery.magnific-popup.min.js');
			$this->document->addStyle('catalog/view/javascript/jquery/magnific/magnific-popup.css');

			$this->document->setTitle($information_info['meta_title']);
			$this->document->setDescription($information_info['meta_description']);
			$this->document->setKeywords($information_info['meta_keyword']);

			$url = '';

			if (isset($this->request->get['path'])) {
				$url .= '&path=' . $this->request->get['path'];
			}

			if (isset($this->request->get['filter'])) {
				$url .= '&filter=' . $this->request->get['filter'];
			}

			if (isset($this->request->get['manufacturer_id'])) {
				$url .= '&manufacturer_id=' . $this->request->get['manufacturer_id'];
			}

			if (isset($this->request->get['brand_id'])) {
				$url .= '&brand_id=' . $this->request->get['brand_id'];
			}

			if (isset($this->request->get['search'])) {
				$url .= '&search=' . $this->request->get['search'];
			}

			if (isset($this->request->get['tag'])) {
				$url .= '&tag=' . $this->request->get['tag'];
			}

			if (isset($this->request->get['description'])) {
				$url .= '&description=' . $this->request->get['description'];
			}

			if (isset($this->request->get['category_id'])) {
				$url .= '&category_id=' . $this->request->get['category_id'];
			}

			if (isset($this->request->get['sub_category'])) {
				$url .= '&sub_category=' . $this->request->get['sub_category'];
			}

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			if (isset($this->request->get['limit'])) {
				$url .= '&limit=' . $this->request->get['limit'];
			}

			$data['breadcrumbs'][] = array(
				'text' => $information_info['title'],
                'href' => $this->url->link('information/information', $url . '&information_id=' . $information_id)
			);

			$data['heading_title'] = $information_info['header'] ? $information_info['header'] : $information_info['title'];

			$this->load->model('catalog/review');

			$data['text_review'] = sprintf($this->language->get('text_review'), $information_info['reviews']);

			$data['information_id'] = $information_id;
			$data['author'] = $information_info['author'];
			$data['date_added'] = date($this->language->get('date_format_information'), strtotime($information_info['date_added']));
			$data['manufacturer'] = $information_info['manufacturer'];
			$data['manufacturers'] = $this->url->link('information/manufacturer/info', 'manufacturer_id=' . $information_info['manufacturer_id']);
			$data['brand'] = $information_info['brand'];
			$data['brands'] = $this->url->link('information/brand/info', 'brand_id=' . $information_info['brand_id']);
			$data['short_description'] = html_entity_decode($information_info['short_description'], ENT_QUOTES, 'UTF-8');
			$data['description'] = html_entity_decode($information_info['description'], ENT_QUOTES, 'UTF-8');

            $documents = $this->model_catalog_information->getInformationDocuments($this->request->get['information_id']);

            $data['documents'] = array();
            $db = 0;

            foreach ($documents as $value) {
                $size = '';
                if (file_exists(DIR_DOWNLOAD . $value['document'])) {
                    $size = filesize(DIR_DOWNLOAD . $value['document']);
                } elseif (file_exists($value['document'])) {
                    $size = filesize($value['document']);
                }
                if ($size) {
                    $i = 0;
                    $db ++;
                    $suffix = array(
                        'B',
                        'KB',
                        'MB'
                    );
                    while (($size / 1024) > 1) {
                        $size = $size / 1024;
                        $i++;
                    }
                    $data['documents'][] = array(
                        'name' => !empty($value['document_name']) ? $value['document_name'] : $value['document'],
                        'size' => round(substr($size, 0, strpos($size, '.') + 4), 2) . ' ' . $suffix[$i],
                        'href' => $this->url->link('information/information/download', 'filename=' . $value['document'], true)
                    );
                }
            }

            $data['tab_document'] = sprintf($this->language->get('tab_document'), $db);

			$this->load->model('tool/image');

			if ($information_info['image']) {
				$data['popup'] = $this->model_tool_image->resize($information_info['image'], $this->config->get('theme_' . $this->config->get('config_theme') . '_image_popup_width'), $this->config->get('theme_' . $this->config->get('config_theme') . '_image_popup_height'));
			} else {
				$data['popup'] = '';
			}

			if ($information_info['image']) {
				$data['thumb'] = $this->model_tool_image->resize($information_info['image'], $this->config->get('theme_' . $this->config->get('config_theme') . '_image_thumb_width'), $this->config->get('theme_' . $this->config->get('config_theme') . '_image_thumb_height'));
			} else {
				$data['thumb'] = '';
			}

			$data['images'] = array();

			$results = $this->model_catalog_information->getInformationImages($information_id);

			foreach ($results as $result) {
				$data['images'][] = array(
					'popup' => $this->model_tool_image->resize($result['image'], $this->config->get('theme_' . $this->config->get('config_theme') . '_image_popup_width'), $this->config->get('theme_' . $this->config->get('config_theme') . '_image_popup_height')),
					'thumb' => $this->model_tool_image->resize($result['image'], $this->config->get('theme_' . $this->config->get('config_theme') . '_image_additional_width'), $this->config->get('theme_' . $this->config->get('config_theme') . '_image_additional_height'))
				);
			}

            // Social share
            $data['social_share_status'] = $this->config->get('theme_default_social_share_status');
            $data['social_share'] = $this->config->get('theme_default_social_share_toolbox');

			if ($this->config->get('theme_default_social_share_status') && !empty($this->config->get('information_exclusion_information_share')) && in_array($information_id, $this->config->get('information_exclusion_information_share'))) {
				$data['show_share'] = false;
			} elseif (!$this->config->get('theme_default_social_share_status') && !empty($this->config->get('information_exclusion_information_share')) && in_array($information_id, $this->config->get('information_exclusion_information_share'))){
				$data['show_share'] = true;
			} else {
				$data['show_share'] = $this->config->get('theme_default_social_share_status');
			}

			//$data['share'] = $this->url->link('information/information', 'information_id=' . $information_id);

            $data['review_status'] = $this->config->get('information_review_status');

			if ($this->config->get('information_review_guest')) {
				$data['review_guest'] = true;
			} else {
				$data['review_guest'] = false;
			}

			$data['reviews'] = sprintf($this->language->get('text_reviews'), (int)$information_info['reviews']);
			$data['rating'] = (int)$information_info['rating'];

			// Captcha
			if ($this->config->get('captcha_' . $this->config->get('information_captcha') . '_status') && $this->config->get('information_captcha')) {
				$data['captcha'] = $this->load->controller('extension/captcha/' . $this->config->get('information_captcha'));
			} else {
				$data['captcha'] = '';
			}

			$data['attribute_groups'] = $this->model_catalog_information->getInformationAttributes($information_id);

			$data['informations'] = array();

			$results = $this->model_catalog_information->getInformationRelated($information_id);

			foreach ($results as $result) {
				if ($result['image']) {
					$image = $this->model_tool_image->resize($result['image'], $this->config->get('theme_' . $this->config->get('config_theme') . '_image_related_width'), $this->config->get('theme_' . $this->config->get('config_theme') . '_image_related_height'));
				} else {
					$image = false;
				}

				if ($this->config->get('information_review_status')) {
					$rating = (int)$result['rating'];
				} else {
					$rating = false;
				}

				$data['informations'][] = array(
					'information_id' => $result['information_id'],
					'thumb'          => $image,
					'title'          => $result['title'],
					'description'    => !empty($result['short_description']) ? trim(html_entity_decode($result['short_description'], ENT_QUOTES, 'UTF-8')) : utf8_substr(trim(strip_tags(html_entity_decode($result['description'], ENT_QUOTES, 'UTF-8'))), 0, $this->config->get('theme_' . $this->config->get('config_theme') . '_information_description_length')) . '...',
					'user_id'        => $result['user_id'],
                    //'team_id'        => $result['team_id'],
					'author'         => $result['author'],
					'date_added'     => date($this->language->get('date_format_short'), strtotime($result['date_added'])),
					'reviews'        => sprintf($this->language->get('text_related_reviews'), $result['reviews']),
					'rating'         => $rating,
					'href'           => $this->url->link('information/information', 'information_id=' . $result['information_id'])
				);
			}

			$data['tags'] = array();

			if ($information_info['tag']) {
				$tags = explode(',', $information_info['tag']);

				foreach ($tags as $tag) {
					$data['tags'][] = array(
						'tag'  => trim($tag),
						'href' => $this->url->link('information/search', 'tag=' . trim($tag))
					);
				}
			}

			$this->model_catalog_information->updateViewed($information_id);

			if (!empty($this->config->get('information_exclusion')) && in_array($information_id, $this->config->get('information_exclusion'))) {
				$data['information_exclusion'] = true;
			} else {
				$data['information_exclusion'] = false;
			}

			if ($this->config->get('information_information_author') && !empty($this->config->get('information_exclusion_information_author')) && in_array($information_id, $this->config->get('information_exclusion_information_author'))) {
				$data['show_author'] = false;
			} elseif (!$this->config->get('information_information_author') && !empty($this->config->get('information_exclusion_information_author')) && in_array($information_id, $this->config->get('information_exclusion_information_author'))){
				$data['show_author'] = true;
			} else {
				$data['show_author'] = $this->config->get('information_information_author');
			}

			if ($this->config->get('information_information_date') && !empty($this->config->get('information_exclusion_information_date')) && in_array($information_id, $this->config->get('information_exclusion_information_date'))) {
				$data['show_date'] = false;
			} elseif (!$this->config->get('information_information_date') && !empty($this->config->get('information_exclusion_information_date')) && in_array($information_id, $this->config->get('information_exclusion_information_date'))){
				$data['show_date'] = true;
			} else {
				$data['show_date'] = $this->config->get('information_information_date');
			}

			if ($this->config->get('information_information_review') && !empty($this->config->get('information_exclusion_information_review')) && in_array($information_id, $this->config->get('information_exclusion_information_review'))) {
				$data['show_review'] = false;
			} elseif (!$this->config->get('information_information_review') && !empty($this->config->get('information_exclusion_information_review')) && in_array($information_id, $this->config->get('information_exclusion_information_review'))){
				$data['show_review'] = true;
			} else {
				$data['show_review'] = $this->config->get('information_information_review');
			}

			if ($this->config->get('information_information_manufacturer') && !empty($this->config->get('information_exclusion_information_manufacturer')) && in_array($information_id, $this->config->get('information_exclusion_information_manufacturer'))) {
				$data['show_manufacturer'] = false;
			} elseif (!$this->config->get('information_information_manufacturer') && !empty($this->config->get('information_exclusion_information_manufacturer')) && in_array($information_id, $this->config->get('information_exclusion_information_manufacturer'))){
				$data['show_manufacturer'] = true;
			} else {
				$data['show_manufacturer'] = $this->config->get('information_information_manufacturer');
			}

			if ($this->config->get('information_information_brand') && !empty($this->config->get('information_exclusion_information_brand')) && in_array($information_id, $this->config->get('information_exclusion_information_brand'))) {
				$data['show_brand'] = false;
			} elseif (!$this->config->get('information_information_brand') && !empty($this->config->get('information_exclusion_information_brand')) && in_array($information_id, $this->config->get('information_exclusion_information_brand'))){
				$data['show_brand'] = true;
			} else {
				$data['show_brand'] = $this->config->get('information_information_brand');
			}


			//$data['show_related_author'] = $this->config->get('information_category_author');
			//$data['show_related_date'] = $this->config->get('information_category_date');
			//$data['show_related_review'] = $this->config->get('information_category_review');

			$data['continue'] = $this->url->link('common/home');

            $data['content_full'] = $this->load->controller('common/content_full');
			$data['column_left'] = $this->load->controller('common/column_left');
			$data['column_right'] = $this->load->controller('common/column_right');
			$data['content_top'] = $this->load->controller('common/content_top');
			$data['content_bottom'] = $this->load->controller('common/content_bottom');
			$data['footer'] = $this->load->controller('common/footer');
			$data['header'] = $this->load->controller('common/header');

			$this->response->setOutput($this->load->view('information/information', $data));
		} else {
			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_error'),
                'href' => $this->url->link('information/information', $url . '&information_id=' . $information_id)
			);

			$this->document->setTitle($this->language->get('text_error'));

			$data['heading_title'] = $this->language->get('text_error');

			$data['text_error'] = $this->language->get('text_error');

			$data['continue'] = $this->url->link('common/home');

			$this->response->addHeader($this->request->server['SERVER_PROTOCOL'] . ' 404 Not Found');

            $data['content_full'] = $this->load->controller('common/content_full');
			$data['column_left'] = $this->load->controller('common/column_left');
			$data['column_right'] = $this->load->controller('common/column_right');
			$data['content_top'] = $this->load->controller('common/content_top');
			$data['content_bottom'] = $this->load->controller('common/content_bottom');
			$data['footer'] = $this->load->controller('common/footer');
			$data['header'] = $this->load->controller('common/header');

			$this->response->setOutput($this->load->view('error/not_found', $data));
		}
	}

	public function review() {
		$this->load->language('information/information');

		$this->load->model('catalog/review');

		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

		$data['reviews'] = array();

		$review_total = $this->model_catalog_review->getTotalReviewsByInformationId($this->request->get['information_id']);

		$results = $this->model_catalog_review->getReviewsByInformationId($this->request->get['information_id'], ($page - 1) * 5, 5);

		foreach ($results as $result) {
			$data['reviews'][] = array(
				'author'     => $result['author'],
				'text'       => nl2br($result['text']),
				'reply'      => html_entity_decode($result['reply'], ENT_QUOTES, 'UTF-8'),
				'rating'     => (int)$result['rating'],
				'date_added' => date($this->language->get('date_format_short'), strtotime($result['date_added']))
			);
		}

		$pagination = new Pagination();
		$pagination->total = $review_total;
		$pagination->page = $page;
		$pagination->limit = 5;
		$pagination->url = $this->url->link('information/information/review', 'information_id=' . $this->request->get['information_id'] . '&page={page}');

		$data['pagination'] = $pagination->render();

		$data['results'] = sprintf($this->language->get('text_pagination'), ($review_total) ? (($page - 1) * 5) + 1 : 0, ((($page - 1) * 5) > ($review_total - 5)) ? $review_total : ((($page - 1) * 5) + 5), $review_total, ceil($review_total / 5));

		$this->response->setOutput($this->load->view('information/review', $data));
	}

	public function write() {
		$this->load->language('information/information');

		$json = array();

		if ($this->request->server['REQUEST_METHOD'] == 'POST') {
			if ((utf8_strlen($this->request->post['name']) < 3) || (utf8_strlen($this->request->post['name']) > 25)) {
				$json['error'] = $this->language->get('error_name');
			}

			if ((utf8_strlen($this->request->post['text']) < 25) || (utf8_strlen($this->request->post['text']) > 1000)) {
				$json['error'] = $this->language->get('error_text');
			}

			if (empty($this->request->post['rating']) || $this->request->post['rating'] < 0 || $this->request->post['rating'] > 5) {
				$json['error'] = $this->language->get('error_rating');
			}

			// Captcha
			if ($this->config->get('captcha_' . $this->config->get('information_captcha') . '_status') && $this->config->get('information_captcha')) {
				$captcha = $this->load->controller('extension/captcha/' . $this->config->get('information_captcha') . '/validate');

				if ($captcha) {
					$json['error'] = $captcha;
				}
			}

			if (!isset($json['error'])) {
				$this->load->model('catalog/review');

				$this->model_catalog_review->addInformationReview($this->request->get['information_id'], $this->request->post);

				$json['success'] = $this->language->get('text_success');
			}
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
            
    public function download() {

        if (file_exists($this->request->get['filename'])) {
            $file = $this->request->get['filename'];
        } else {
            $file = !empty($this->request->get['docfile']) ? $this->request->get['docfile'] : DIR_DOWNLOAD . $this->request->get['filename'];
        }

        if (!headers_sent()) {
            if (file_exists($file)) {
                // open file or save file //
                header('Content-Type: application/octet-stream');
                header('Content-Disposition: attachment; filename="' . basename($file). '"');
                header('Expires: 0');
                header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                header('Pragma: public');
                header('Content-Length: ' . filesize($file));

                if (ob_get_level()) {
                    ob_end_clean();
                }

                readfile($file, 'rb');
                exit();

            } else {
                exit('Error: Could not find file' . $file . '!');
            }
        } else {
            exit('Error: Headers already sent out!');
        }
    }
}