<?php
class ControllerInformationSitemap extends Controller {
	public function index() {
		$this->load->language('information/sitemap');

		$this->document->setTitle($this->language->get('heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('information/sitemap')
		);

		$this->load->model('catalog/category');

		$data['categories'] = array();

		$categories_1 = $this->model_catalog_category->getCategories(0);

		foreach ($categories_1 as $category_1) {
			if ($category_1['information']) {
				$level_2_data = array();

				$categories_2 = $this->model_catalog_category->getCategories($category_1['category_id']);

				foreach ($categories_2 as $category_2) {
					$level_3_data = array();

					$categories_3 = $this->model_catalog_category->getCategories($category_2['category_id']);

					foreach ($categories_3 as $category_3) {
					$level_3_data[] = array(
							'name' => $category_3['name'],
							'href' => $this->url->link('information/category', 'path=' . $category_1['category_id'] . '_' . $category_2['category_id'] . '_' . $category_3['category_id'])
						);
					}

					$level_2_data[] = array(
						'name'     => $category_2['name'],
						'children' => $level_3_data,
						'href'     => $this->url->link('information/category', 'path=' . $category_1['category_id'] . '_' . $category_2['category_id'])
					);
				}

				$data['information_categories'][] = array(
					'name'     => $category_1['name'],
					'children' => $level_2_data,
					'href'     => $this->url->link('information/category', 'path=' . $category_1['category_id'])
				);

				continue;
			}

			$level_2_data = array();

			$categories_2 = $this->model_catalog_category->getCategories($category_1['category_id']);

			foreach ($categories_2 as $category_2) {
				$level_3_data = array();

				$categories_3 = $this->model_catalog_category->getCategories($category_2['category_id']);

				foreach ($categories_3 as $category_3) {
					$level_3_data[] = array(
						'name' => $category_3['name'],
						'href' => $this->url->link('information/category', 'path=' . $category_1['category_id'] . '_' . $category_2['category_id'] . '_' . $category_3['category_id'])
					);
				}

				$level_2_data[] = array(
					'name'     => $category_2['name'],
					'children' => $level_3_data,
					'href'     => $this->url->link('information/category', 'path=' . $category_1['category_id'] . '_' . $category_2['category_id'])
				);
			}

			$data['categories'][] = array(
				'name'     => $category_1['name'],
				'children' => $level_2_data,
				'href'     => $this->url->link('information/category', 'path=' . $category_1['category_id'])
			);
		}

        // Team
		$this->load->model('catalog/team');

        if ($this->config->get('theme_default_team_menu') && $this->config->get('theme_default_team_menu') == 1) {
            $data['team'] = $this->url->link('information/team');
        }

        // Manufacturer
		$this->load->model('catalog/manufacturer');

        if ($this->config->get('theme_default_manufacturer_menu') && $this->config->get('theme_default_manufacturer_menu') == 1) {
            $data['manufacturer'] = $this->url->link('information/manufacturer');
        }

        // Brand
		$this->load->model('catalog/brand');

        if ($this->config->get('theme_default_brand_menu') && $this->config->get('theme_default_brand_menu') == 1) {
            $data['brand'] = $this->url->link('information/brand');
        }

        // Webshop link
        if ($this->config->get('config_webshop_link')) {
            $data['webshop_link'] = $this->config->get('config_webshop_link');
        }

        $data['contact'] = $this->url->link('information/contact');
        $data['search'] = $this->url->link('information/search');

		$this->load->model('catalog/information');

		$data['informations'] = array();

		foreach ($this->model_catalog_information->getInformations() as $result) {
			if ($this->model_catalog_information->getMainCategory($result['information_id'])) {
				continue;
			}
			$data['informations'][] = array(
				'title' => $result['title'],
				'href'  => $this->url->link('information/information', 'information_id=' . $result['information_id'])
			);
		}

		$data['heading_title'] = $this->language->get('heading_title');
        $data['content_full'] = $this->load->controller('common/content_full');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');

		$this->response->setOutput($this->load->view('information/sitemap', $data));
	}
}