<?php
class ControllerInformationTeam extends Controller {
	public function index() {
		$this->load->language('information/team');

		$this->load->model('catalog/team');

		$this->load->model('tool/image');

		$this->document->setTitle($this->language->get('heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_team'),
			'href' => $this->url->link('information/team')
		);

		$data['categories'] = array();

		$results = $this->model_catalog_team->getTeams();

		foreach ($results as $result) {
			if (is_numeric(utf8_substr($result['team_group'], 0, 1))) {
				$key = '0 - 9';
			} else {
				$key = $result['team_group'];
			}

			if (!isset($data['categories'][$key])) {
				$data['categories'][$key]['team_group'] = $key;
			}

            if ($result['image']) {
                $image['thumb'] = $this->model_tool_image->resize($result['image'], $this->config->get('theme_' . $this->config->get('config_theme') . '_image_team_width'), $this->config->get('theme_' . $this->config->get('config_theme') . '_image_team_height'));
            } else {
                $image['thumb'] = $this->model_tool_image->resize('placeholder.png', $this->config->get('theme_' . $this->config->get('config_theme') . '_image_team_width'), $this->config->get('theme_' . $this->config->get('config_theme') . '_image_team_height'));
            }
            
			$data['categories'][$key]['team'][] = array(
                'thumb' => $image['thumb'],
				'fullname' => $result['fullname'],
                'team_group'  => $result['team_group'],
				'description' => $result['description'],
				'phone' => $result['phone'],
				'email' => $result['email']
			);
		}

		$data['heading_title'] = $this->language->get('heading_title');
		$data['continue'] = $this->url->link('common/home');

        $data['content_full'] = $this->load->controller('common/content_full');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');

		$this->response->setOutput($this->load->view('information/team', $data));
	}
}
