<?php
class ControllerStartupSeoUrl extends Controller {
	public function index() {
		// Add rewrite to url class
		if ($this->config->get('config_seo_url')) {
			$this->url->addRewrite($this);
		}

		// Decode URL
		if (isset($this->request->get['_route_'])) {
			$parts = explode('/', $this->request->get['_route_']);

			// remove any empty arrays from trailing
			if (utf8_strlen(end($parts)) == 0) {
				array_pop($parts);
			}

			foreach ($parts as $part) {
				$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "seo_url WHERE keyword = '" . $this->db->escape($part) . "' AND site_id = '" . (int)$this->config->get('config_site_id') . "'");

				if ($query->num_rows) {
					$url = explode('=', $query->row['query']);

					if ($url[0] == 'category_id') {
						if (!isset($this->request->get['path'])) {
							$this->request->get['path'] = $url[1];
						} else {
							$this->request->get['path'] .= '_' . $url[1];
						}
					}

					if ($url[0] == 'team_id') {
						$this->request->get['team_id'] = $url[1];
					}

					if ($url[0] == 'manufacturer_id') {
						$this->request->get['manufacturer_id'] = $url[1];
					}

					if ($url[0] == 'brand_id') {
						$this->request->get['brand_id'] = $url[1];
					}

					if ($url[0] == 'information_id') {
						$this->request->get['information_id'] = $url[1];
					}

					if ($query->row['query'] && $url[0] != 'information_id' && $url[0] != 'team_id' && $url[0] != 'manufacturer_id' && $url[0] != 'brand_id' && $url[0] != 'category_id') {
						$this->request->get['route'] = $query->row['query'];
					}
				} else {
					$this->request->get['route'] = 'error/not_found';

					break;
				}
			}

			if (!isset($this->request->get['route'])) {
				if (isset($this->request->get['path']) && !isset($this->request->get['information_id'])) {
					$this->request->get['route'] = 'information/category';
				} elseif (isset($this->request->get['team_id'])) {
					$this->request->get['route'] = 'information/team/info';
				} elseif (isset($this->request->get['manufacturer_id'])) {
					$this->request->get['route'] = 'information/manufacturer/info';
				} elseif (isset($this->request->get['brand_id'])) {
					$this->request->get['route'] = 'information/brand/info';
				} elseif (isset($this->request->get['information_id'])) {
					$this->request->get['route'] = 'information/information';
				}
			}
		}
	}

	public function rewrite($link) {
		$url_info = parse_url(str_replace('&amp;', '&', $link));

		$url = '';

		$data = array();

		parse_str($url_info['query'], $data);

		foreach ($data as $key => $value) {
			if (isset($data['route'])) {
				if (($data['route'] == 'information/information' && $key == 'information_id') || (($data['route'] == 'information/manufacturer/info' || $data['route'] == 'information/information') && $key == 'manufacturer_id') || (($data['route'] == 'information/brand/info' || $data['route'] == 'information/information') && $key == 'brand_id') || (($data['route'] == 'information/team/info' || $data['route'] == 'information/information') && $key == 'team_id')) {
					$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "seo_url WHERE `query` = '" . $this->db->escape($key . '=' . (int)$value) . "' AND site_id = '" . (int)$this->config->get('config_site_id') . "' AND language_id = '" . (int)$this->config->get('config_language_id') . "'");

					if ($query->num_rows && $query->row['keyword']) {
						$url .= '/' . $query->row['keyword'];

						unset($data[$key]);
					}
				} elseif ($data['route'] == 'common/home') {

					$url .= '/';

					unset($data[$key]);

                } elseif ($key == 'route') {
                    $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "seo_url WHERE `query` = '" . $this->db->escape($value) . "' AND site_id = '" . (int)$this->config->get('config_site_id') . "' AND language_id = '" . (int)$this->config->get('config_language_id') . "'");
                    
                    if ($query->num_rows && $query->row['keyword']) {
                        $url .= '/' . $query->row['keyword'];
                        
                        unset($data[$key]);

                    } else if ($data['route'] == "common/home") {
                        $url .= '/';
                    }

                } elseif ($key == 'path') {
					$categories = explode('_', $value);

					foreach ($categories as $category) {
						$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "seo_url WHERE `query` = 'category_id=" . (int)$category . "' AND site_id = '" . (int)$this->config->get('config_site_id') . "' AND language_id = '" . (int)$this->config->get('config_language_id') . "'");

						if ($query->num_rows && $query->row['keyword']) {
							$url .= '/' . $query->row['keyword'];
						} else {
							$url = '';

							break;
						}
					}

					unset($data[$key]);
				}
			}
		}

		if ($url) {
			unset($data['route']);

			$query = '';

			if ($data) {
				foreach ($data as $key => $value) {
				  //$query .= '&' . rawurlencode((string)$key) . '=' . rawurlencode((is_array($value) ? http_build_query($value) : (string)$value));
                    $query .= '&' . rawurlencode((string)$key) . '=' . rawurlencode(is_array($value) ? http_build_query($value) : (string)$value);
                    //$query .= '&' . http_build_query($data); deze gebruiken als seo niet goed werkt
				}

				if ($query) {
				  //$query = '?' . str_replace('&', '&amp;', trim($query, '&'));
                    $query = '?' . str_replace('&', '&amp;', trim(str_replace('%2F', '/', $query), '&'));
				}
			}

			return $url_info['scheme'] . '://' . $url_info['host'] . (isset($url_info['port']) ? ':' . $url_info['port'] : '') . str_replace('/index.php', '', $url_info['path']) . $url . $query;
		} else {
			return $link;
		}
	}
}
