<?php
class ModelCatalogTeam extends Model {
	public function getTeam($team_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "team t LEFT JOIN " . DB_PREFIX . "team_description td ON (t.team_id = td.team_id) LEFT JOIN " . DB_PREFIX . "team_to_site t2s ON (t.team_id = t2s.team_id) WHERE t.team_id = '" . (int)$team_id . "' AND td.language_id = '" . (int)$this->config->get('config_language_id') . "' AND t2s.site_id = '" . (int)$this->config->get('config_site_id') . "' AND t.status = '1'");
        return $query->row;
	}

	public function getTeams($data = array()) {
		$sql = "SELECT *, (SELECT tgd.name FROM " . DB_PREFIX . "team_group_description tgd WHERE tgd.team_group_id = t.team_group_id AND tgd.language_id = '" . (int)$this->config->get('config_language_id') . "') AS team_group FROM " . DB_PREFIX . "team t LEFT JOIN " . DB_PREFIX . "team_description td ON (t.team_id = td.team_id) WHERE td.language_id = '" . (int)$this->config->get('config_language_id') . "' AND t.status = '1'";


		if (!empty($data['filter_name'])) {
			$sql .= " AND tdg.name LIKE '" . $this->db->escape($data['filter_name']) . "%'";
		}

		if (!empty($data['filter_description'])) {
			$sql .= " AND td.description LIKE '" . $this->db->escape($data['filter_description']) . "%'";
		}

		if (!empty($data['filter_team_group_id'])) {
			$sql .= " AND t.team_group_id = '" . $this->db->escape($data['filter_team_group_id']) . "'";
		}

		$sort_data = array(
			'team_group',
			't.sort_order'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY team_group, t.sort_order";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->rows;
	}

    /*public function getTotalTeams() {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "team" . "' WHERE status = '1'");

		return $query->row['total'];
	}*/
}